<?php

use bin\{WbAdaptor,SecureTokens,Sanitize};
use bin\helpers\{PreCheck};
use vendor\phplib\Template;

    $sAddonPath = str_replace('\\','/',\dirname(__DIR__)).'/';
    $sPattern = "/^(.*?\/)modules\/.*$/";
    $sAppPath = preg_replace ($sPattern, "$1", $sAddonPath, 1 );
    if (!defined('SYSTEM_RUN')) {require($sAppPath.'/config.php');}
    // to print with or without header, default is with header
    $admin_header=true;
    // Workout if the developer wants to show the info banner
    $print_info_banner = true; // true/false
    // Tells script to update when this page was last updated
    $update_when_modified = false;
    // Include WB admin wrapper script to sanitize page_id and section_id, print SectionInfoLine
    require(WB_PATH.'/modules/admin.php');
try {
    if (\is_readable($sAddonPath.'/init.php')) {require ($sAddonPath.'/init.php');}
    $sSectionIdPrefix = (defined('SEC_ANCHOR') && !empty(SEC_ANCHOR)  ? SEC_ANCHOR : 'Sec' );
//    $section_id = $oApp->getIdFromRequest('section_id');
    $sBacklink = ADMIN_URL.'/pages/modify.php?page_id='.$page_id.'#'.$sSectionIdPrefix;
    $sSynclink = $sAddonUrl.'/admin/sync.php?page_id='.$page_id.'&section_id='.$section_id;

    if (is_null($section_id)){
        $aMessage = \sprintf("%s\n",$MESSAGE['GENERIC_SECURITY_ACCESS']);
        throw new \Exception ($aMessage);
    }

//    if (\is_readable($sAddonPath.'/presets/thumbPresets.php')){require($sAddonPath.'/presets/thumbPresets.php');}
/*
    $sQueryString = '?page_id='.(int)$page_id.'&amp;section_id='.(int)$section_id;
    $sBacklink = ADMIN_URL.'/pages/modify.php'.$sQueryString;
*/


    $aFtan = SecureTokens::getFTAN();
    $sFtanQuery = sprintf('%s=%s',$aFtan['name'],$aFtan['value']);

/*
    if (!SecureTokens::checkFTAN ()) {
        $admin->print_error($MESSAGE['GENERIC_SECURITY_ACCESS'], $sBacklink );
    }
*/

// Get all Folders in this gallery
    $settings = getFGSettings($section_id);
    $invisibleFileNames = array_merge(explode(',', $settings['invisible']), $wbCoreFolders);
    $aOptionList = getFolderData($path.$settings['root_dir'], [], $invisibleFileNames, 2);

// Template
    $t = new Template($sAddonThemePath);
    $t->halt_on_error = 'no';
    $t->set_file('new_cat', 'new_cat.htt');
    // clear the comment-block, if present
    $t->set_block('new_cat', 'CommentDoc'); $t->clear_var('CommentDoc');
    $t->set_block('new_cat', 'select_option_block', 'select_option');

    $t->set_var($aTplDefaults);

// set language strings
    $t->set_var([
        'NEW_CAT_TITLE'         => $MOD_FOLDERGALLERY['NEW_CAT'],
        'CAT_PARENT_STRING'     => $MOD_FOLDERGALLERY['CAT_PARENT'],
        'FOLDER_NAME_STRING'    => $MOD_FOLDERGALLERY['FOLDER_NAME'],
        'CAT_TITLE_STRING'      => $MOD_FOLDERGALLERY['CAT_TITLE'],
        'CAT_DESC_STRING'       => $MOD_FOLDERGALLERY['CAT_DESC'],
        'SAVE_STRING'           => $TEXT['SAVE'],
        'CANCEL_STRING'         => $TEXT['CLOSE']
    ]);
// filter all sub folder in root dir
    $aFolders = [];
    $iPrevLevel = substr_count($settings['root_dir'],'/');
    foreach($aOptionList[trim($oReg->MediaDir, '/')] as $sKey=>$aValue) {
        $aValue['key'] = $sKey = str_replace($oReg->MediaDir,'',$sKey);
        $iLevel = $aValue['level'] = substr_count($sKey, '/')-$iPrevLevel;
        $pattern = '/'.preg_quote($settings['root_dir'], '/').'/is';
        if (preg_match($pattern, ($sKey))){
            $aFolders[$sKey] = $aValue;
            $aFolders[$sKey]['level']  = $iLevel;
            $aFolders[$sKey]['select'] = ((($aValue['level'])>0) ? str_repeat(' -- ', $aValue['level']).$aValue['name'] : $aValue['name']);
        }
    }

    foreach($aFolders as $sKey=>$sValue) {
        $t->set_var('FOLDER', $sKey);
        $t->set_var('FOLDER_NAME', ($sValue['select']));
        $t->set_var('NIVEAU', ($sValue['level']));
        if($sKey != $settings['root_dir']) {
            $t->set_var('DIR_SELECTED','');
        } else {
            $t->set_var('DIR_SELECTED','selected="selected"');
        }
        $t->parse('select_option', 'select_option_block', true);
    }

// set the links and other actions
    $t->set_var([
        'ROOT'              => $settings['root_dir'],
        'SECTION_ID_VALUE'  => $section_id,
        'PAGE_ID_VALUE'     => $page_id,
        'ADDON_URL'         => $sAddonUrl,
        'ADMIN_URL'         => ADMIN_URL,
//        'NEW_CAT_LINK'      => $sAddonUrl.'/admin/save_new_cat.php?page_id='.$page_id.'&section_id='.$section_id,
//        'CANCEL_ONCLICK'    => 'window.location = \''.ADMIN_URL.'/pages/modify.php?page_id='.$page_id.'\';'
        'NEW_CAT_LINK'      => '?page_id='.$page_id.'&section_id='.$section_id,
        'CANCEL_ONCLICK'    => '?page_id='.$page_id.'',
        'FTAN_NAME'         => $aFtan['name'],
        'FTAN_VALUE'        => $aFtan['value'],
    ]);

    $t->pparse('Output', 'new_cat');


}catch (\Exception $ex) {
//    $admin->print_header();
    $sErrMsg = PreCheck::xnl2br(\sprintf('[%d] %s', $ex->getLine(), $ex->getMessage()));
    $admin->print_error ($sErrMsg, $sBacklink);
    exit;
}
    $admin->print_footer();

