<?php

use bin\{WbAdaptor,SecureTokens,Sanitize};

    $sAddonPath = str_replace('\\','/',\dirname(__DIR__)).'/';
    $sPattern = "/^(.*?\/)modules\/.*$/";
    $sAppPath = preg_replace ($sPattern, "$1", $sAddonPath, 1 );

    if (!defined('SYSTEM_RUN')) {require($sAppPath.'/config.php');}
    // to print with or without header, default is with header
    $admin_header=true;
    // Workout if the developer wants to show the info banner
    $print_info_banner = false; // true/false
    // Tells script to update when this page was last updated
    $update_when_modified = false;
    // Include WB admin wrapper script to sanitize page_id and section_id, print SectionInfoLine
    require(WB_PATH.'/modules/admin.php');
    if (\is_readable($sAddonPath.'/init.php')) {require ($sAddonPath.'/init.php');}

    $sSamelink = $sAddonUrl.'/admin/new_cat.php?page_id='.$page_id.'&section_id='.$section_id;
    $sSectionIdPrefix = (defined('SEC_ANCHOR') && !empty(SEC_ANCHOR) ? SEC_ANCHOR : 'Sec' );
    $sBacklink = ADMIN_URL.'/pages/modify.php?page_id='.$page_id.'#'.$sSectionIdPrefix.$section_id;
    $sSynclink = $sAddonUrl.'/admin/sync.php?page_id='.$page_id.'&section_id='.$section_id;

    if (!bin\SecureTokens::checkFTAN ()) {
        $aMessage = \sprintf("%s\n",$MESSAGE['GENERIC_SECURITY_ACCESS']);
//        throw new \Exception ($aMessage);
        $admin->print_error($aMessage, $sBacklink );
    }

    $aFtan = SecureTokens::getFTAN();
    $sFtanQuery = sprintf('%s=%s',$aFtan['name'],$aFtan['value']);

// Validate Data
    $v = new Validator();
    $v->setData($aRequestVars);
    $v->setKeys([
        'section_id'    => 'integer',
        'page_id'       => 'integer',
        'root'          => 'string',
        'cat_parent'    => 'string',
        'folder_name'   => 'string',
        'cat_title'     => 'string',
        'cat_desc'      => 'string',
    ]);
    $v->process();
    $request = $v->getValidData();
// This is used to prevent SQL attacks
    $request['root']        = $admin->StripCodeFromText($request['root']);
    $request['cat_parent']  = $admin->StripCodeFromText($request['cat_parent']);
    $request['folder_name'] = $v->getSaveFilename($request['folder_name']);
    $request['cat_title']   = $admin->StripCodeFromText($request['cat_title']);
    $request['cat_desc']    = $admin->StripCodeFromText($request['cat_desc']);

// Get the settings for this section
    $settings = getFGSettings($section_id);

    $request['cat_parent'] = str_replace([$request['root'],$settings['root_dir']], '', $request['cat_parent']);
// Check if Parent Directory exists
    if ($request['cat_parent'] == '/') { $request['cat_parent'] = ''; }
    $request['cat_parent'] = ((rtrim($oReg->MediaDir,'/')!=ltrim($request['cat_parent'],'/')) ? $request['cat_parent'] : '');

    $parentDir = $parent_dir = $request['cat_parent'];
    $aChilds    = explode('/', trim($parent_dir, '/'));
    $parent_dir_last = '/'.end($aChilds);

    if($request['folder_name'] == '') {
        $aMessage = sprintf("%s\n%s ",$MESSAGE['MOD_FORM_REQUIRED_FIELDS'],$MOD_FOLDERGALLERY['FOLDER_NAME']);
        $admin->print_error(nl2br($aMessage), $sSamelink);
    }
    if($request['cat_title'] == '') {
        $request['cat_title'] = $aRequestVars['folder_name'];
    }

    if($request['cat_title'] == '') {
        $admin->print_error($MESSAGE['MOD_FORM_REQUIRED_FIELDS'].'<br />'.$MOD_FOLDERGALLERY['CAT_TITLE'].' ', $sBacklink);
    }

    $sMessage = sprintf('[%d] An error occured during creating a new directory (%s)!',__LINE__,$parentDir);
    if (!is_dir(WB_PATH.MEDIA_DIRECTORY.$settings['root_dir'].$parentDir)) {
        $admin->print_error($sMessage, $sBacklink);
    }

    $new_dir = WB_PATH.MEDIA_DIRECTORY.$settings['root_dir'].$parentDir.'/'.$request['folder_name'];

     make_dir($new_dir);

// get the parent id from the database
    $sql  = 'SELECT `id`, `niveau`, `childs` FROM `'.TABLE_PREFIX.'mod_foldergallery_categories` '
          . 'WHERE section_id='.$request['section_id'].' '
          .   'AND CONCAT(`parent`,\'\', `categorie`) = \''.ltrim($parent_dir,'/').'\';';
    if (($query = $database->query($sql))){
        if (($result = $query->fetchRow(MYSQLI_ASSOC))){
          $parent_id = (int) $result['id'];
          $niveau = $result['niveau'] + 1;
          $childs = explode(',',$result['childs']);
// OK, prepare the Insert SQL:
          $sql  = 'INSERT INTO `'.TABLE_PREFIX.'mod_foldergallery_categories` SET '.$sqlEOL
                . '`section_id`='.(int)$request['section_id'].', '.$sqlEOL
                . '`parent_id`=\''.$parent_dir.'\', '.$sqlEOL
                . '`parent`='.(int)$parent_id.', '.$sqlEOL
                . '`categorie`=\''.$request['folder_name'].'\', '.$sqlEOL
                . '`cat_name`=\''.$request['cat_title'].'\', '.$sqlEOL
                . '`description`=\''.$request['cat_desc'].'\', '.$sqlEOL
                . '`is_empty`=0, '.$sqlEOL
                . '`niveau`='.$niveau.', '.$sqlEOL
                . '`active`=1 '.$sqlEOL;
          $database->query($sql);
      }
    }

// OK, now update the parent_categorie
    $sql  = 'SELECT `id` FROM `'.TABLE_PREFIX.'mod_foldergallery_categories` '
          . 'WHERE `section_id`='.$request['section_id'].' '
          .   'AND CONCAT(`parent`, \'/\', `categorie`) = \''.$request['cat_parent'].'/'.$request['folder_name'].'\';';
    if (($query = $database->query($sql)))
        if (($result = $query->fetchRow(MYSQLI_ASSOC))){
            $cat_id = $result['id'];
            $childs = ltrim(implode(',',$childs), ',');
            $sql = 'UPDATE `'.TABLE_PREFIX.'mod_foldergallery_categories` '
                   .'SET `has_child` = 1, `childs` = \''.$childs.'\' '
                   .'WHERE `id` = '.$parent_id.';';
            $database->query($sql);
        }

    $admin->print_success($TEXT['SUCCESS'], $sSynclink); // $sBacklink

    $admin->print_footer();
