<?php

/**
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Description of Lingual
 *
 */
use bin\{
    WbAdaptor,
    SecureTokens,
    Sanitize,
    Wbdatabase
};
use bin\helpers\{
    PreCheck,
    msgQueue
};
use vendor\pclzip\PclZip;
use vendor\phplib\Template;

$sAddonPath = str_replace('\\', '/', \dirname(__DIR__)) . '/';
$sPattern = "/^(.*?\/)modules\/.*$/";
$sAppPath = preg_replace($sPattern, "$1", $sAddonPath, 1);
if (!defined('SYSTEM_RUN')) {
    require($sAppPath . '/config.php');
}
// to print with or without header, default is with header
$admin_header = true;
// Workout if the developer wants to show the info banner
$print_info_banner = false; // true/false
// Tells script to update when this page was last updated
$update_when_modified = false;
// Include WB admin wrapper script to sanitize page_id and section_id, print SectionInfoLine
require(WB_PATH . '/modules/admin.php');
try {
    if (\is_readable($sAddonPath . '/init.php')) {
        require ($sAddonPath . '/init.php');
    }

    if (\is_readable($sAddonPath . '/presets/thumbPresets.php')) {
        require($sAddonPath . '/presets/thumbPresets.php');
    }
    $OK = '<span class="ok">OK</span>';
    $FAIL = '<span class="error">FAILED</span>';
    $aSynch = [];
    $oldSettings = [];
    $newSettings = [];
    $aOldSettings = [];
    $aNewSettings = [];
    $aSettings = null;
    $aErrorMsg = [];
    $aInvisibile = explode(',', $aDefaults['invisible']);
    $sBackLink = ADMIN_URL . '/pages/modify.php?page_id=' . (int) $page_id;
    $sFGLinkUrl = $sAddonUrl . '/admin/modify_settings.php?page_id=' . (int) $page_id . '&section_id=' . (int) $section_id;
    $sBacklinkUrl = (isset($aRequestVars['save']) ? $sFGLinkUrl : $sBackLink);
    $sLocalDebug = (is_readable($sAddonPath . '/.setDebug'));
    $sSecureToken = (!is_readable($sAddonPath . '/.setToken'));
    $sPHP_EOL = $sqlEOL = ($sLocalDebug ? "\n" : '');
    /**/
    if (!SecureTokens::checkFTAN()) {
        $sBacklinkUrl = $sBackLink;
        $aMessage = \sprintf("%s\n", $MESSAGE['GENERIC_SECURITY_ACCESS']);
        throw new \Exception($aMessage);
//        $admin->print_error($MESSAGE['GENERIC_SECURITY_ACCESS'], $sBacklink );
    }

    $oldSettings = getFGSettings($section_id);

    $AddCategorie = (function ($section_id, $sCatTitle) use ($sqlEOL, $database) {
                $mRetval = null;
                $table = TABLE_PREFIX . 'mod_foldergallery_categories';
                $index = 'root';
                $sqlWhere = 'WHERE `categorie` = \'' . $index . '\' ' . $sqlEOL
                          . 'AND `section_id`=' . (int) $section_id . '' . $sqlEOL;
                $sSql[1]  = 'SELECT `categorie` FROM `' . $table . '` '
                        . $sqlWhere;
                if ($database->get_one($sSql[1])) {
                    $sqlType = 'UPDATE ';
                    $sqlNew = '';
                } else {
                    $sqlType = 'INSERT INTO ';
                    $sqlNew = ''
                            . '`categorie`=\'' . 'root' . '\', ' . $sqlEOL
//                          . '`cat_name`=\''.basename($settings['root_dir']).'\', '.$sqlEOL
                            . '`cat_name`=\'' . $database->escapeString(ltrim($sCatTitle, '/')) . '\', ' . $sqlEOL
                            . '`description`= \'\', ' . $sqlEOL
                            . '`parent`=-1, ' . $sqlEOL
                            . '`parent_id`=-1, ' . $sqlEOL
                            . '`childs`=\'\', ' . $sqlEOL
                            . '`niveau`=-1, ' . $sqlEOL
                            . '`has_child`=0, ' . $sqlEOL;
                    $sqlWhere = '';
                }
// insert into or update root
                $sSql[2] = $sqlType . ' `' . $table . '` SET ' . $sqlEOL
                        . $sqlNew
                        . '`section_id`=' . (int) $section_id . ', ' . $sqlEOL
                        . '`active`=1, ' . $sqlEOL
                        . '`is_empty`=0, ' . $sqlEOL
                        . '`position`=0 ' . $sqlEOL
                        . $sqlWhere;
                if (!($mRetval = $database->query($sSql[2]))) {
                    $mRetval = $database->get_error();
                }
                return $mRetval;
            }); // $AddCategorie
    $aVars = $oReg->Request->getParamNames();
//    $aVars = $oRequest->getParamNames();
    foreach ($aVars as $sName) {
        $aRequestVars[$sName] = $oRequest->getParam($sName);
    }
    $aOldSettings = $oldSettings;

    $aInputs = array_diff_assoc($aOldSettings, $aRequestVars);

    if (isset($page_id)) {
        $newSettings['page_id'] = $admin->StripCodeFromText($page_id);
    } else {
        $newSettings['page_id'] = $page_id;
    }
    if (isset($aRequestVars['cat_pp']) && is_numeric($aRequestVars['cat_pp'])) {
        $newSettings['cat_pp'] = intval($aRequestVars['cat_pp']);
    } else {
        $newSettings['cat_pp'] = -1;
    }
    if (isset($aRequestVars['catpic']) && is_numeric($aRequestVars['catpic'])) {
        $newSettings['catpic'] = intval($aRequestVars['catpic']);
    } else {
        $newSettings['catpic'] = 0;
    }
    if (isset($aRequestVars['cat_pp']) && is_numeric($aRequestVars['cat_pp'])) {
        $newSettings['cat_pp'] = intval($aRequestVars['cat_pp']);
    } else {
        $newSettings['cat_pp'] = -1;
    }

    //Daten aus $aRequestVars auswerten und validieren
    if (isset($aRequestVars['root_dir'])) {
        $aRequestVars['root_dir'] = str_replace($MediaAddonRel, '', $aRequestVars['root_dir']);
        $newSettings['root_dir'] = filter_var($aRequestVars['root_dir'], FILTER_SANITIZE_FULL_SPECIAL_CHARS, FILTER_FLAG_STRIP_LOW | FILTER_FLAG_STRIP_HIGH);

    } else {
        $newSettings['root_dir'] = '';
    }

    if (isset($aRequestVars['extensions']) && ($aRequestVars['extensions'] != '')) {
        $extensions = strtolower($aRequestVars['extensions']);
        $extensionsarray = explode(',', str_replace(' ', '', $extensions));
        $extensionsarray = array_unique($extensionsarray);
        $newSettings['extensions'] = implode(',', $extensionsarray);
    } else {
        $newSettings['extensions'] = '';
    }
    if (isset($aRequestVars['invisible'])) {
        $newSettings['invisible'] = $admin->StripCodeFromText($aRequestVars['invisible']);
        $aForbidden['invisible'] = array_diff($aInvisibile, explode(',', $newSettings['invisible']));
        $sForbidden = ',' . implode(',', $aForbidden['invisible']);
        $newSettings['invisible'] = trim($newSettings['invisible'] . $sForbidden, ',');
    } else {
        $newSettings['invisible'] = $aDefaults['invisible'];
    }
    if (isset($aRequestVars['pics_pp']) && is_numeric($aRequestVars['pics_pp'])) {
        $newSettings['pics_pp'] = intval($aRequestVars['pics_pp']);
    } else {
        $newSettings['pics_pp'] = 10;
    }
    if (isset($aRequestVars['gal_pp']) && is_numeric($aRequestVars['gal_pp'])) {
        $newSettings['gal_pp'] = intval($aRequestVars['gal_pp']);
    } else {
        $newSettings['gal_pp'] = -1;
    }
    if (isset($aRequestVars['alignment'])) {
        $newSettings['alignment'] = $admin->StripCodeFromText($aRequestVars['alignment']);
    } else {
        $newSettings['alignment'] = 'left';
    }
    if (isset($aRequestVars['pagination']) && is_readable($sAddonTemplatePath . '/css/digg/' . $aRequestVars['pagination'] . '.css')) {
        $newSettings['pagination'] = $admin->StripCodeFromText($aRequestVars['pagination']);
    } else {
        $newSettings['pagination'] = 'FlickrStyle';
    }

    if (isset($aRequestVars['lightbox']) && is_readable($sAddonTemplatePath . '/view_' . $aRequestVars['lightbox'] . '.htt')) {
        $newSettings['lightbox'] = $aRequestVars['lightbox'];
// ----- jQueryAdmin / LibraryAdmin Integration; last edited 27.01.2011 -----
    } elseif (isset($aRequestVars['lightbox']) && is_readable(WB_PATH . '/modules/' . $aRequestVars['lightbox'] . '/foldergallery_template.htt')) {
        $newSettings['lightbox'] = $aRequestVars['lightbox'];
    } elseif (isset($aRequestVars['lightbox']) && is_readable(WB_PATH . '/modules/jqueryadmin/plugins/' . $aRequestVars['lightbox'] . '/foldergallery_template.htt')) {
        $newSettings['lightbox'] = $aRequestVars['lightbox'];
// ----- end jQueryAdmin / LibraryAdmin Integration -----
    } else {
        $newSettings['lightbox'] = 'Colorbox';
    }
    if (isset($aRequestVars['loadPreset'])) {
        $newSettings['loadPreset'] = $admin->StripCodeFromText($aRequestVars['loadPreset']);
    } else {
        $newSettings['loadPreset'] = '1:1Croped150';
    }

    if (isset($aRequestVars['galleryStyle'])) {
        $newSettings['galleryStyle'] = $admin->StripCodeFromText($newSettings['galleryStyle']);
    } else {
        $newSettings['galleryStyle'] = 'default';
    }

    if (isset($aRequestVars['imageName'])) {
        $newSettings['imageName'] = (int) $aRequestVars['imageName'];
    } else {
        $newSettings['imageName'] = '0';
    }

    if (isset($aRequestVars['defaultQuality'])) {
        $newSettings['defaultQuality'] = $admin->StripCodeFromText($aRequestVars['defaultQuality']);
    } else {
        $newSettings['defaultQuality'] = '60';
    }
    if (isset($aRequestVars['opacity'])) {
        $newSettings['opacity'] = $admin->StripCodeFromText($aRequestVars['opacity']);
    } else {
        $newSettings['opacity'] = '0';
    }

    if (isset($aRequestVars['maxImageSize'])) {
        $newSettings['maxImageSize'] = $admin->StripCodeFromText($aRequestVars['maxImageSize']);
    } else {
        $newSettings['maxImageSize'] = '1024';
    }

    if (isset($aRequestVars['clearLangCache']) && ($aRequestVars['clearLangCache'] = '1')) {
        Translate::getInstance()->clearCache();
    }

    if (isset($aRequestVars['noNew'])) {
        $bForceThumbnails = true;
    } else {
        $bForceThumbnails = false;
    }

    if (isset($aRequestVars['forceThumbnails']) && ($aRequestVars['forceThumbnails'] = '1')) {
        $bForceThumbnails = true;
    } else {
        $bForceThumbnails = false;
    }

    $newSettings['section_id'] = $section_id;
//    $newSettings['page_id'] = $page_id;

    // Get the new Thumbsettings:
    if (isset($aRequestVars['thumb_x']) && is_numeric($aRequestVars['thumb_x'])) {
        $newSettings['tbSettings']['image_x'] = (int) trim($aRequestVars['thumb_x']);
    } else {
        $newSettings['tbSettings']['image_x'] = 150;
    }
    if (isset($aRequestVars['thumb_y']) && is_numeric($aRequestVars['thumb_y'])) {
        $newSettings['tbSettings']['image_y'] = (int) trim($aRequestVars['thumb_y']);
    } else {
        $newSettings['tbSettings']['image_y'] = 150;
    }
    if (isset($aRequestVars['thumb_crop']) && is_string($aRequestVars['thumb_crop']) && $aRequestVars['thumb_crop'] == 'keep') {
        $newSettings['tbSettings']['image_ratio_fill'] = true;
        $newSettings['tbSettings']['image_ratio_crop'] = false;
    } else {
        $newSettings['tbSettings']['image_ratio_fill'] = false;
        $newSettings['tbSettings']['image_ratio_crop'] = true;
    }
    if (isset($aRequestVars['background_color']) && is_string($aRequestVars['background_color'])) {
        $newSettings['tbSettings']['image_background_color'] = '#' . trim($aRequestVars['background_color'], '#');
    } else {
        $newSettings['tbSettings']['image_background_color'] = '#FFFFFF';
    }
    // Fetch the advanced settings, they need a little bit more effort...
    if (isset($aRequestVars['thumb_advanced']) && is_string($aRequestVars['thumb_advanced']) && $aRequestVars['thumb_advanced'] != '') {
        $advanced_settings = setFGAdvancedThumbSettings($aRequestVars['thumb_advanced']);
        $newSettings['tbSettings'] = array_merge($newSettings['tbSettings'], $advanced_settings);
    }
    // This is set by default as we want to resize the images
    $newSettings['tbSettings']['image_resize'] = true;

    if (isset($aRequestVars['thumb_width']) && is_numeric($aRequestVars['thumb_width'])) {
        $newSettings['thumb_width'] = (int) trim($aRequestVars['thumb_width']);
    } else {
        $newSettings['thumb_width'] = 150;
    }
    if (isset($aRequestVars['thumb_height']) && is_numeric($aRequestVars['thumb_height'])) {
        $newSettings['thumb_height'] = (int) trim($aRequestVars['thumb_height']);
    } else {
        $newSettings['thumb_height'] = 150;
    }

    if (isset($aRequestVars['thumbDirName']) && is_string($aRequestVars['thumbDirName'])) {
        $newSettings['thumbDirName'] = ($aRequestVars['thumbDirName']);
    } else {
        $newSettings['thumbDirName'] = ($thumbDirName ?? 'fg_thumbs');
    }

    if (isset($aRequestVars['thumbPath']) && is_string($aRequestVars['thumbPath'])) {
        $newSettings['thumbPath'] = ($aRequestVars['thumbPath']);
    } else {
        $newSettings['thumbPath'] = ($thumbPath ?? '/fg_thumbs');
    }
    ?><div class="w3-panel w3-leftbar w3-pale-green w3-border-green w3-round">
        <h5 ><?php echo $MOD_FOLDERGALLERY['SAVE_SETTINGS']; ?></h5>
    </div><!-- SAVE_SETTINGS -->
<?php
    //SQL wich is used for all updates statement with placeholders
    $sTable = TABLE_PREFIX . 'mod_foldergallery_settings';
    $sSqllWhere = '';
    $sNameValPairs = '';
    foreach ($newSettings as $index => $val) {
        if (is_array($val)) {
            $sNameValPairs .= ', ( ' . (int) $section_id . ', \'' . $index . '\', \'' . $oDb->escapeString(serialize($val)) . '\')' . PHP_EOL;
        } else {
            $sNameValPairs .= ', ( ' . (int) $section_id . ', \'' . $index . '\', \'' . $oDb->escapeString($val) . '\')' . PHP_EOL;
        }
    }
    $sValues = ltrim($sNameValPairs, ', ');
    $sSql[1] = 'REPLACE INTO `' . $sTable . '` (`section_id`, `s_name`, `s_value`) '
            . 'VALUES ' . $sValues;

    if (!$oDb->query($sSql[1])) {
        $msg[] = sprintf("<strong>update settings failed</strong>\n%s", $oDb->get_error());
        $iErr = true;
    }
    if ($oDb->is_error()){
        $msg[] = sprintf("<strong>update settings failed</strong>\n%s", $oDb->get_error());
        $iErr = true;
    }

/*
      $Update_SQL = 'UPDATE `'.TABLE_PREFIX.'mod_foldergallery_settings` SET '.$sqlEOL;
      $rawUpdtSQL = '`s_value` = \'%1$s\' '.$sqlEOL
      . 'WHERE `section_id` = '.(int)$section_id.' '.$sqlEOL
      .   'AND `s_name` = \'%2$s\''.$sqlEOL
      . ''.$sqlEOL;
      // execute SQL
      $sUpdateSql =[];
      $sSql[1] = '';
      foreach ($newSettings as $s_name=>$s_value){
      if (!is_array($s_value)) {
      $sSql[1] .= sprintf($rawUpdtSQL, $database->escapeString($s_value), $s_name);
      } else {
      $sSql[1] .= sprintf($rawUpdtSQL, serialize($s_value), $s_name);
      }

      $sUpdateSql[] = $sSql[1];
      if (!$database->query($sSql[1])){
      }
      if ($database->is_error()) {
      $sErrorMsg = sprintf('%s :: %s <br />%s', \basename(__FILE__), $database->get_error(), $sSql);
      $aErrorMsg[] = $sErrorMsg;
      throw new \Exception ($sErrorMsg);
      }
      }// end foreach new settings
*/
    if (count($aErrorMsg)) {
//      $admin->print_error(implode('<br />', $aErrorMsg), $sBacklinkUrl);
        $sErrorMsg = PreCheck::xnl2br($aErrorMsg);
        throw new \Exception(sprintf($sErrorMsg));
    }

    ksort($newSettings);
    ksort($oldSettings);
/*
      $aSettings['newSettings'] = $newSettings;
      $aSettings['oldSettings'] = $oldSettings;
*/
    $aDiffSettings = array_diff_assoc($oldSettings['tbSettings'], $newSettings['tbSettings']);
    $isDiffTbSettings = count($aDiffSettings);

//    $bFired = true;
    $aSynch = array_multi_diff($newSettings, $oldSettings);
    unset($oldSettings['tbSettings']);
    unset($newSettings['tbSettings']);

    $bFired = (!empty($aSynch) || $isDiffTbSettings || $bForceThumbnails);
    if (($isDiffTbSettings && !isset($aRequestVars['noNew'])) || $bForceThumbnails) {
        // Ok, thumb_size hat gewechselt, also alte Thumbs löschen
        $sSql[2] = 'SELECT `parent`, `categorie` FROM `' . TABLE_PREFIX . 'mod_foldergallery_categories` ' . $sqlEOL
                . 'WHERE `section_id`=' . (int) $oldSettings['section_id'] . ';' . $sqlEOL;
        if (($query = $database->query($sSql[2]))) {
//        if ($query->numRows()) {
?>
            <div class="w3-section w3-panel w3-leftbar w3-pale-red w3-border-red w3-round w3-border-green">
                <h5><?php echo $MOD_FOLDERGALLERY['DELETE_OLD_THUMBS']; ?></h5>
                <ul class=" w3-margin-bottom">
<?php
                    $pathToFolder = $oldSettings['root_dir'] . $thumbPath;
                    $sThumbPath = $path . $pathToFolder;
                    ?><li><?php echo $MOD_FOLDERGALLERY['DELETE']; ?> : <?php echo $pathToFolder; ?></li>
<?php
                    deleteFolder($sThumbPath);
                    while (!is_null($link = $query->fetchRow(MYSQLI_ASSOC))) {
                        $pathToFolder = $oldSettings['root_dir'] . $link['parent'] . '/' . ltrim($link['categorie'], '/\\') . $thumbPath;
                        $sThumbPath = $path . $pathToFolder;
                        ?><li><?php echo $MOD_FOLDERGALLERY['DELETE']; ?> : <?php echo $pathToFolder; ?></li>
<?php
                            deleteFolder($sThumbPath);
                        }
?>
                </ul>
            </div>
<?php
        } else {
?>
            <!-- no fg-thumbs -->
<?php
        } // numRows
    } // serialize($oldSettings['tbSettings']

    $sNewCatTitle = \basename($newSettings['root_dir']);
    $sCatTitle = $sNewCatTitle;
    $sCatTitle = $database->escapeString(($sCatTitle == '') ? basename($path) : $sCatTitle);

    if ($AddCategorie($section_id, $sCatTitle)) {
        $sSql['info'][] = 'INSERT INTO `' . TABLE_PREFIX . 'mod_foldergallery_categories`';
    }

    $isDiffRootdir = (bool) ($oldSettings['root_dir'] !== $newSettings['root_dir']);
    if ($isDiffRootdir) {
        // categorie exists so delete files and old categorie entry
        $sSql[3] = 'SELECT `id`, `categorie` FROM `' . TABLE_PREFIX . 'mod_foldergallery_categories` ' . $sqlEOL
                . 'WHERE `section_id` = ' . (int) $oldSettings['section_id'] . ' ' . $sqlEOL;
        if (($query = $database->query($sSql[3]))) {
            while (!is_null($cat = $query->fetchRow(MYSQLI_ASSOC))) {
                $sSql[4] = 'DELETE FROM `' . TABLE_PREFIX . 'mod_foldergallery_files` ' . $sqlEOL
                        . 'WHERE `parent_id` = ' . (int) $cat['id'] . $sqlEOL;
                $database->query($sSql[4]);
            }
            $sSql[5] = 'DELETE FROM `' . TABLE_PREFIX . 'mod_foldergallery_categories` ' . $sqlEOL
                    . 'WHERE `section_id` = ' . (int) $oldSettings['section_id'] . ' ' . $sqlEOL;
            if ($database->query($sSql[5])) {
                // insert Root as new categorie
                if ($AddCategorie($section_id, $sCatTitle)) {
                    $sSql['info'][] = 'INSERT INTO `' . TABLE_PREFIX . 'mod_foldergallery_categories`';
                }
            }
        } // end of categorie exists
    } // new rootdir
    /*

     */
    // Jetzt wird die DB neu synchronisiert //Anm CHio: Wozu? Wenn ein Fehler ist, kann man nichtmal die Settings speichern.
//    syncDB($newSettings);
    // Ãœberprüfen ob ein Fehler aufgetreten ist, sonst Erfolg ausgeben
    if ($database->is_error()) {
        $sErrorMsg = sprintf('%s :: %s', \basename(__FILE__), $database->get_error());
        throw new \Exception(sprintf($sErrorMsg));
//        $admin->print_error($sErrorMsg, $sBacklinkUrl);
    } else {
        $sBackLink = ADMIN_URL . '/pages/modify.php?page_id=' . (int) $page_id;
        if ($bFired) {
            include ($sAddonPath . '/admin/sync.php');
        }
//        $sBackLink = $sAddonUrl.'/admin/sync.php?page_id='.(int)$page_id.'&section_id='.(int)$section_id;
//        $admin->print_success(sprintf('[%d] %s',__LINE__,$TEXT['SUCCESS']), $sBackLink);
    }
} catch (\Exception $ex) {
    $sErrMsg = PreCheck::xnl2br(\sprintf('[%d] %s', $ex->getLine(), $ex->getMessage()));
    $admin->print_error($sErrMsg, $sBacklinkUrl);
    exit;
}
if (!$bFired) {
    $admin->print_success(sprintf('[%d] %s', __LINE__, $TEXT['SUCCESS']), $sBacklinkUrl);
}

// Print admin footer
$admin->print_footer();
