<?php
/*
 * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS HEADER.
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

use bin\{WbAdaptor,SecureTokens,Sanitize};
use bin\helpers\{PreCheck,msgQueue};
use src\Security\{CsfrTokens,Randomizer};
use src\Interfaces\Requester;
use bin\Requester\HttpRequester;

    if (!\defined('SYSTEM_RUN')) {require(\dirname(\dirname(\dirname(\dirname(__DIR__)))).'/config.php');}

try {

    // Include WB admin wrapper script
    $update_when_modified = false;
// Tells script to update when this page was last updated
    $admin_header = true;
    require(WB_PATH.'/modules/admin.php');
    $sAddonBackUrl = ADMIN_URL.'/pages/modify.php';

// Get id
    if (isset($aRequestVars['page_id']) && is_numeric($aRequestVars['page_id'])) {
        $sAddonBackUrl .= '?page_id='.$page_id;
        if (isset($aRequestVars['id']) && is_numeric($aRequestVars['id'])) {
            $page_id = $aRequestVars['page_id'];
            $id = $aRequestVars['id'];
            $id_field = 'id';
            $common_field = 'parent_id';
            $table = TABLE_PREFIX.'mod_foldergallery_categories';
        }
    } else {
       $aMessage = \sprintf('page_id not set');
       throw new \Exception ($aMessage);
    }

// Create new admin object and print admin header
//if (!class_exists('admin')){ include(WB_PATH.'/framework/class.admin.php'); }
//    $admin = new admin('Pages', 'pages_settings');

// Include the ordering class
//require(WB_PATH.'/framework/class.order.php');

// Create new order object an reorder
    $order = new order($table, 'position', $id_field, $common_field);
    if($id_field == 'id') {
        if($order->move_up($id)) {
//            $admin->print_success($MESSAGE['PAGES_REORDERED'], ADMIN_URL.'/pages/modify.php?page_id='.$page_id);
        } else {
//            $admin->print_error($MESSAGE['PAGES_CANNOT_REORDER'], ADMIN_URL.'/pages/modify.php?page_id='.$page_id);
           $aMessage = \sprintf('move up failed for id_field %s',$id_field);
           throw new \Exception ($aMessage);
        }
    } else {
        if($order->move_up($id)) {
//            $admin->print_success($TEXT['SUCCESS'], ADMIN_URL.'/pages/modify.php?page_id='.$page_id);
        } else {
//            $admin->print_error($TEXT['ERROR'], ADMIN_URL.'/pages/modify.php?page_id='.$page_id);
           $aMessage = \sprintf('move up failed for id_field %s',$id_field);
           throw new \Exception ($aMessage);
        }
    }

} catch (\Exception $ex) {
    $sErrMsg = PreCheck::xnl2br(\sprintf('[%03d] %s', $ex->getLine(), $ex->getMessage()));
    $admin->print_error ($sErrMsg, $sAddonBackUrl);
    exit;
}
    $order->get_new($id);
    $sExtra = '';
    $aMessage = PreCheck::xnl2br(sprintf('%s %s ',$sExtra,$MESSAGE['PAGES_REORDERED']));
    $admin->print_success($aMessage, $sAddonBackUrl);

// Print admin footer
    $admin->print_footer();

