<?php

use bin\{WbAdaptor,SecureTokens,Sanitize};
use bin\helpers\{PreCheck,msgQueue};
use vendor\pclzip\PclZip;
use vendor\phplib\Template;

// folderstructure steps to WB_PATH
    $sModulePath = str_replace('\\','/',\dirname(__DIR__)).'/';
    $sPattern = "/^(.*?\/)modules\/.*$/";
    $sAppPath = preg_replace ($sPattern, "$1", $sModulePath, 1 );
    if (!defined('SYSTEM_RUN')) {require($sAppPath.'/config.php');}
    $sAddonName = basename(__DIR__);
    $sAddonPath = $sModulePath.$sAddonName;
    // to print with or without header, default is with header
    $admin_header=true;
    // Workout if the developer wants to show the info banner
    $print_info_banner = true; // true/false
    // Tells script to update when this page was last updated
    $update_when_modified = false;
    // Include WB admin wrapper script
    require(WB_PATH.'/modules/admin.php');
    if (is_readable($sAddonPath.'/init.php')){require ($sAddonPath.'/init.php');}

// include the default language
    if (is_readable($sAddonPath.'/help/EN.php')) {require_once($sAddonPath.'/help/EN.php');}
// check if module language file exists for the language set by the user (e.g. DE, EN)
    if (is_readable($sAddonPath.'/help/'.LANGUAGE.'.php')) {require($sAddonPath.'/help/'.LANGUAGE.'.php');}
    if (is_readable($sAddonPath.'/info.php')){require ($sAddonPath.'/info.php');}

//Template
$t = new Template($sAddonPath.'/help');
$t->set_file('help', 'help.htt');
// clear the comment-block, if present
$t->set_block('help', 'CommentDoc'); $t->clear_var('CommentDoc');

$t->set_var(array(
    'TITLE'                 => $FG_HELP['TITLE'],
    'VERSION'               => $FG_HELP['VERSION'],
    'YOUR_VERSION_TEXT'     => sprintf($FG_HELP['YOUR_VERSION'],($module_version ?? 'unknown')),
    'VERSION_TEXT'          => $FG_HELP['VERSION_TEXT'],
    'HOMEPAGE_TEXT'         => $FG_HELP['HOMEPAGE_TEXT'],
    'HELP_TITLE'            => $FG_HELP['HELP_TITLE'],
    'HELP_TEXT'             => $FG_HELP['HELP_TEXT'],
    'BUG_TITLE'             => $FG_HELP['BUG_TITLE'],
    'BUG_TEXT'              => $FG_HELP['BUG_TEXT'],
    'BACK_STRING'           => $FG_HELP['BACK_STRING'],
    'BACK_ONCLICK'          => 'window.location = \''.ADMIN_URL.'/pages/modify.php?page_id='.$page_id.'\';'
));

$t->pparse('output', 'help');

$admin->print_footer();

// end of file
