<?php
/**
  This module is free software. You can redistribute it and/or modify it under
  the terms of the GNU General Public License - version 2 or later, as published
  by the Free Software Foundation: http://www.gnu.org/licenses/gpl.html.

  This module is distributed in the hope that it will be useful, but
  WITHOUT ANY WARRANTY; without even the implied warranty of
  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
  GNU General Public License for more details.

 -------------------------------------------------------------------------------
  Modul: foldergallery fuer Website Baker v2.10.0 (http://websitebaker.org)
  Modulbeschreibung: Eine einfache Bildergalerie erstellen anhand der
  Ordnerstruktur auf dem Server. Im Backend kann zu jedem Bild/jeder Kategorie
  eine Beschreibung angegeben werden.

 -------------------------------------------------------------------------------
 * The Changelog of this Module can be found in the README.markdown file!
 -------------------------------------------------------------------------------
**/
//declare(strict_types = 1);
//declare(encoding = 'UTF-8');

//namespace addon\foldergallery;
use bin\{WbAdaptor,SecureTokens,Sanitize};
use bin\helpers\{PreCheck,msgQueue,ParentList};
use src\Security\{CsfrTokens,Randomizer};
use src\Interfaces\Requester;
use bin\Requester\HttpRequester;

// only included in init.php may be needed as global if script is called within a function
/* --------------------------------------------------------
global  $sAppPath,
        $sAddonPath,
        $sAddonUrl,
        $sAddonName,
        $sAddonRel,
        $aExtraFields,
        $oReg;
*/
/* -------------------------------------------------------- */
// folderstructure steps to modules path
    $sAddonPath = str_replace('\\','/',__DIR__).'/';$iSteps = 2;
    $sPattern = "/^(.*?\/)modules\/.*$/";
    $sAppPath = preg_replace ($sPattern, "$1", $sAddonPath, 1 );
// load config created for modify or save module files if SYSTEM_RUN don't exist, '
    if (!\defined('SYSTEM_RUN')) {require($sAppPath.'config.php');}
/* -------------------------------------------------------- */
    $sCallingScript = $oReg->Request->getServerVar('SCRIPT_NAME');
    $sLocalDebug  =  is_readable($sAddonPath.'.setDebug');
    $sSecureToken = !is_readable($sAddonPath.'.setToken');
    $sqlEOL     = ($sLocalDebug ? "\n" : '');
//    $sqlEOL = (\defined('DEBUG') && DEBUG ? PHP_EOL : '');

    $globalStarted = \preg_match('/upgrade\-script\.php$/', $sCallingScript);
    $sWbVersion = ($globalStarted && \defined('VERSION') ? VERSION : WB_VERSION);
/**/
    $oReg     = WbAdaptor::getInstance();
    $oRequest = $oReg->getRequester();
    $oApp     = $oReg->getApplication();

//    $admin = new \admin('Modules', 'modules_modify',false,false);

    switch ($iSteps) {
        case 5:
          $sAddonPath = \dirname($sAddonPath);
        case 4:
          $sAddonPath = \dirname($sAddonPath);
        case 3:
          $sAddonPath = \dirname($sAddonPath);
          break;
    }

    $aRequestVars = null;
    $bExcecuteCommand = false;
    // needed for simple Dispatcher
    $sAddonName = \basename($sAddonPath);
    if (\is_readable(\dirname(__DIR__).'/SimpleCommandDispatcher.inc.php')) {require(\dirname(__DIR__).'/SimpleCommandDispatcher.inc.php');}
    $sCallingScript = $oRequest->getServerVar('SCRIPT_NAME');
    if (empty($aRequestVars)){
        $aRequestVars = [];
        $aVars = $oRequest->getParamNames();
        foreach ($aVars as $sName) {
            $aRequestVars[$sName] = $oRequest->getParam($sName);
        }
    }
/*--------------------------------------------------------------------------------------------------------*/
    $unixPath = (function ($string){
      return \str_replace(['\\','//','\\\\'], '/', $string);
    });
/*--------------------------------------------------------------------------------------------------------*/

/**
 * @param $path
 * @return string
 * @author https://github.com/ozzpy
 */
    $imageEncode = (function ($path)
    {
        $path  = __DIR__."/".$path;
        $image = \file_get_contents($path);
        $finfo = new finfo(FILEINFO_MIME_TYPE);
        $type  = $finfo->buffer($image);
        return "data:".$type.";charset=utf-8;base64,".\base64_encode($image);
    });

/**
 * @param $path
 * @return string
 * @author https://github.com/ozzpy
 */
    $imageEncodePath = (function ($path)
    {
        $image = \file_get_contents($path);
        $finfo = new finfo(FILEINFO_MIME_TYPE);
        $type  = $finfo->buffer($image);
        return "data:".$type.";charset=utf-8;base64,".\base64_encode($image);
    });

/**
 * @param $path
 * @return string
 * @author https://github.com/ozzpy
 */
    $imageEncodeURL = (function ($path)
    {
        $image = \file_get_contents($path);
        $finfo = new finfo(FILEINFO_MIME_TYPE);
        $type  = $finfo->buffer($image);
        return "data:".$type.";charset=utf-8;base64,".\base64_encode($image);
    });

    $base64url_decode = function ($path) {
        $data = \file_get_contents($path);
        return \base64_decode(str_replace(['-', '_'], ['+', '/'], $data),true);
    };

    $base64_decode = function ($path) {
        $data = \file_get_contents($path);
        return \base64_decode($data,true);
    };

/*--------------------------------------------------------------------------------------------------------*/

/**
 *
 */
if (!\function_exists('index_exists')){
    function index_exists($table_name, $index_name, $number_fields = 0)
    {
        $oReg = WbAdaptor::getInstance();
        $database = $oReg->getDatabase();
        $number_fields = \intval($number_fields);
        $keys = 0;
        $sql = 'SHOW INDEX FROM `'.$table_name.'`';
        if (($res_keys = $database->query($sql))) {
            while (($rec_key = $res_keys->fetchAssoc())) {
                if (($rec_key['Key_name'] || ($rec_key['Column_name']) == $index_name)) {
                    $keys++;
                }
            }
        }
        if ( $number_fields == 0 ) {
            return ($keys != $number_fields);
        } else {
            return ($keys == $number_fields);
        }
    }
}

/*  this function/closure is placed inside this file temporarely until a better place is found */
/** function to update a var/value-pair(s) in table ****************************
 *  nonexisting keys are inserted
 *  @param string $table: name of table to use (without prefix)
 *  @param mixed the firring with name of the key to update
 *  @param string $value: a sting with needed value, if $key is a string too
 *  @param array example the first entry is used as WHEE....... AND request
 *                  $aFieldsList = array(
 *                      'section_id' => $section_id,
 *                      'page_id' => $page_id,
 *                  );
 *
 *  @return bool:  true if any keys are updated, otherwise false
 */
if (!\function_exists('UpdateKeyValue')){

    function UpdateKeyValue($table, $key, $value = '', array $aExtraFields = [])
    {
        if( !\is_array($key))
        {
            if (\trim($key) != '' )
            {
                $key = [ \trim($key) => \trim($value) ];
            } else {
                $key = [];
            }
        }
        $retval = [];
        $iFirst = 0;
        $aTmp  = [];
        $aIndexField  = [];
        $sExtraFields = '';
        $oReg = WbAdaptor::getInstance();
        $oDb  = $oReg->getDatabase();
       $TablePrefix  = $oDb->getTablePrefix();
        $sql = 'SHOW FIELDS FROM `'.$TablePrefix.$table.'` ';
        if ($oRes = $oDb->query($sql)){
            while($aRes = $oRes->fetchRow(MYSQLI_ASSOC)){
              if (!isset($aExtraFields[$aRes['Field']])){continue;}
              $aTmp[$aRes['Field']] = $aExtraFields[$aRes['Field']];
              if (index_exists(TABLE_PREFIX.$table, $aRes['Field'])){
                  $aIndexField[] = $aRes['Field'].' = '.$aTmp[$aRes['Field']];
                  $iFirst++;
              }
            }
            $aExtraFieldsList =  \array_intersect_key($aTmp, $aExtraFields);
            foreach($aExtraFieldsList as $sName=>$sValue){
                $sExtraFields .= '`'.$sName.'` = \''.$sValue.'\', ';
            }
        } else {
            $retval[]=$sql;
            $retval[]=$oDb->get_error();
        }
        foreach( $key as $index=>$val)
        {
//            $index = strtolower($index);
            $sql  = 'SELECT COUNT(*) FROM `'.$TablePrefix.$table.'` '
                  . 'WHERE `s_name` = \''.$index.'\' '
                  . (!empty($aIndexField['0']) ? 'AND '. $aIndexField['0'] : '');
            if ($oDb->get_one($sql))
            {
                $sql = 'UPDATE ';
                $sql_where = 'WHERE `s_name` LIKE \''.$index.'\' ';
            } else {
                $sql = 'INSERT INTO ';
                $sql_where = '';
            }
            $sql .= '`'.$TablePrefix.$table.'` SET ';
            $sql .= (($sExtraFields) ? $sExtraFields : '');
            $sql .= '`s_name` = \''.$index.'\', ';
            $sql .= '`s_value` = \''.$val.'\' '.$sql_where;
            if (!$oDb->query($sql))
            {
                $retval[]=$sql;
                $retval[]=$oDb->get_error();
            }
        }
        return ((\count($retval)==0) ? true : $retval);
    };
}
/*--------------------------------------------------------------------------------------*/

/**
*
* Author: CodexWorld
* Author URI: https://www.codexworld.com
* Function Name: rgb2hex2rgb()
* $color => HEX or RGB
* Returns RGB or HEX color format depending on given value.
*
**/
    $ColorConverter = (function ($color)
    {
         $result = [];
        if (!empty($color))
        {
            $color = \trim($color);
            if (\preg_match("/^[0-9ABCDEFabcdef\#]+$/i", $color))
            {
              $hex = \str_replace('#','', $color);
              if(\strlen($hex) == 3){
                 $result['r'] = \hexdec(\substr($hex,0,1).\substr($hex,0,1));
                 $result['g'] = \hexdec(\substr($hex,1,1).\substr($hex,1,1));
                 $result['b'] = \hexdec(\substr($hex,2,1).\substr($hex,2,1));
              } else {
                 $result['r'] = \hexdec(\substr($hex,0,2));
                 $result['g'] = \hexdec(\substr($hex,2,2));
                 $result['b'] = \hexdec(\substr($hex,4,2));
              }
           }elseif (\preg_match("/^[0-9]+(,| |.)+[0-9]+(,| |.)+[0-9]+$/i", $color)){
              $rgbstr = \str_replace(array(',',' ','.'), ':', $color);
              $rgbarr = \explode(":", $rgbstr);
              $result = '#';
              $result .= \str_pad(\dechex($rgbarr[0]), 2, "0", \STR_PAD_LEFT);
              $result .= \str_pad(\dechex($rgbarr[1]), 2, "0", \STR_PAD_LEFT);
              $result .= \str_pad(\dechex($rgbarr[2]), 2, "0", \STR_PAD_LEFT);
              $result = \strtoupper($result);
           } else{
              $result = [];
           }
        }
       return $result;
    });

    $convertToCategory = (function ($sList,$Pattern='/[,=+\;\:\/\|]+/')
    {
      if (\is_array($sList)){
          return $sList;
      }
//    return preg_split('/[\s,=+\;\:\.\/\|]+/', $sList, -1, PREG_SPLIT_NO_EMPTY);
      return \preg_split($Pattern, $sList, -1, \PREG_SPLIT_NO_EMPTY);
    });

    $convertToArray = (function ($sList,$Pattern='/[\s,=+\;\:\-\.\|]+/')
    {
      if (\is_array($sList)){
          return $sList;
      }
      return \preg_split($Pattern, $sList, -1, \PREG_SPLIT_NO_EMPTY);
    });
/*--------------------------------------------------------------------------------------*/

//if (!\function_exists('make_dir'))             {require (WB_PATH.'/framework/functions.php');}
if (!\function_exists('getFGSettings'))        {require ($sAddonPath.'scripts/functions.php');}
if (!\function_exists('getFolderData'))        {require ($sAddonPath.'admin/scripts/backend.functions.php');}

if (!\class_exists('Validator', false))        {require ($sAddonPath.'class/Validator.php');}
if (!\class_exists('DirectoryHandler', false)) {require ($sAddonPath.'class/DirectoryHandler.php');}

/**
 *  Pfad und URL zum Stammverzeichnis der Foldergallery
 *  Das Stammverzeichnis ist das hoechste Verzeichnis
 *  auf welches die Foldergallery zugriff hat.
 *  Die Werte muessen auf das gleiche Verzeichnis zeigen.
 *  Diese Verzeichnisse koennen sie natuerlich aendern!
 *  (z.B) fuer externe Ordner
**/

    $MediaRel      = trim($oReg->MediaDir,'/'); //
    $MediaAddonRel = $MediaRel; ///foldergallery/'/'
    $sUploadFolder = '/uploads'; //.
    $sChunkFolder  = '/chunks'; //.
    $thumbPath     = '/fg-thumbs';
    $path          = $oReg->AppPath.$MediaRel;     // Vorher: WB_PATH.;
    $url           = $oReg->AppUrl;                // Vorher: WB_URL.MEDIA_DIRECTORY;
    $sAddonBaseDir = $path.'/'.$sAddonName;  // Future setting baseDir is the addon folder

    if (!make_dir($sAddonBaseDir)){/* trigger error */}
    if (!make_dir($sAddonBaseDir.$sChunkFolder)){/* trigger error */}
    if (!make_dir($sAddonBaseDir.$sUploadFolder)){/* trigger error */}

    // Des gleiche wie oben, aber ohne Slash
    // Wird fuer die Suche benoetigt
    $thumbDirName  = \trim($thumbPath, '/');
    $chunkDirName  = \trim($sChunkFolder, '/');
    $uploadDirName = \trim($sUploadFolder, '/');

    // bad    $pages = substr(PAGES_DIRECTORY, 1);
    // better
    $pages = \trim(PAGES_DIRECTORY, '/');

    $checked  = ' checked="checked"';
    $selected = ' selected="selected"';

    $sAppUrl  = \rtrim(\str_replace('\\', '/', WB_URL), '/').'/';
    $sAppPath = \rtrim(\str_replace('\\', '/', WB_PATH), '/').'/';
    $sAppRel  = \preg_replace('/^https?:\/\/[^\/]*(.*)$/is', '$1', $sAppUrl);
    $sDocRoot = \preg_replace('/^(.*?)'.\preg_quote($sAppRel, '/').'$/', '$1', $sAppUrl);

/*------------------------------------ changes needed too in presets  -------------------------------*/
    $aThumbSettings = [
        'image_resize'           => true,
        'image_x'                => 150,
        'image_y'                => 150,
        'image_ratio_fill'       => false,
        'image_ratio_crop'       => true,
        'image_background_color' => '#FFFFFF',
        'description'            => '',
    ];

    $aDefaults =  [
        "section_id"      => ($section_id ?? 0),
        "page_id"         => ($page_id ?? 0),
        'background'      => '#ffffff',
        'cat_pp'          => '-1',
        'catpic'          => '',
        'extensions'      => 'jpg,jpeg,gif,png',
        'gal_pp'          => "5",
        'invisible'       => $thumbDirName.','.$chunkDirName.','.$uploadDirName.',thumbs',
        'lightbox'        => 'jqueryFancybox',
        'imageName'       => '',
        'pagination'      => 'NewYahooStyle',
        'galleryStyle'    => 'default',
        'opacity'         => '0.1',
        'alignment'       => 'left',
        "loadPreset"      => "1:1noCrop",
        'pics_pp'         => "20",
        "defaultQuality"  => "85",
        "maxImageSize"    => "1024",
        'ratio'           => "1.34",
        'thumb_width'     => '150',
        'thumb_height'    => '150',
        'thumb_size'      => '150',
        'root_dir'        => '', // .trim($MediaAddonRel,'/')
        'tbSettings'      => \serialize($aThumbSettings),
        'thumbDirName'    => $thumbDirName.'',
        'thumbPath'       => $thumbPath.'',
    ];

/*---------------------------------------------------------------------------------------------------*/
    $oAddonReg = new \stdClass(); // wird später durch ein selbstverwaltetes AddonRegistry-Objekt ersetzt
    $oAddonReg->oReg              = $oReg;
    $oAddonReg->RequestVars       = ($aRequestVars ?? []);
    $oAddonReg->AddonPath         = $sAddonPath;
    $oAddonReg->AddonBaseDir      = $sAddonBaseDir;
    $oAddonReg->AddonThemePath    = ($sAddonThemePath);
    $oAddonReg->AddonTemplatePath = ($sAddonTemplatePath);
    $oAddonReg->AddonRel          = \str_replace($oReg->AppPath, '', $oAddonReg->AddonPath);
    $oAddonReg->AddonUrl          = $oReg->AppUrl.$oAddonReg->AddonRel;
    $oAddonReg->AddonName         = $sAddonName;
    $oAddonReg->AddonClass        = 'm_'.$sAddonName.'_Addon';
    if( \preg_match( '/'.'pages\/(modify)\.php$/is', $sCallingScript)) {
        $oAddonReg->PageId        = (isset($page_id) ? $page_id : '0');
        $oAddonReg->SectionId     = (isset($section_id) ? $section_id : 0);
    }
    $oAddonReg->aDefaults         = $aDefaults;
    $oAddonReg->Records           = $aDefaults;
    $sAddonUrl = $oAddonReg->AddonUrl;
    \Translate::getInstance ()->enableAddon ('modules\\'.$sAddonName);
    $aLangFG = \Translate::getInstance ()->getLangArray();
    $aData = \json_encode($oAddonReg,  JSON_PRETTY_PRINT|JSON_UNESCAPED_SLASHES);

// insert needed javascript variables to template
$sModule = '
<script>
    if (typeof '.\strtoupper($sAddonName).' === \'undefined\')
    {
        var '.\strtoupper($sAddonName).' = {
            WB_URL             : "'.$oReg->AppUrl.'",
            AppRel             : "'.$sAppRel.'",
            AddonUrl           : "'.$sAddonUrl.'",
            ModulesTemplateUrl : "'.($bIsBackend ? $sAddonThemeUrl : $sAddonTemplateUrl).'",
            AddonThemeUrl      : "'.$sAddonThemeUrl.'/",
            AddonTemplateUrl   : "'.$sAddonTemplateUrl.'",
            AddonName          : "'.$sAddonName.'",
            MediaRel           : "'.$MediaRel.'",
            MediaAddonRel      : "'.$MediaRel.'/'.$sAddonName.'/",
        };
    };
</script>
'."\n";

    $aTplDefaults = [
          'ADDON_NAME' => \strtoupper($sAddonName),
          'AppUrl' =>  $oReg->AppUrl,
          'AppRel' => $sAppRel,
          'AddonName'=> $sAddonName,
          'sAddonUrl' => $sAddonUrl.'',
          'AddonThemeUrl'  => $sAddonUrl.'themes/default/',
          'AddonUrl' => $sAddonUrl,
          'sAddonThemeUrl'  => $sAddonUrl.'themes/default/',
          'ModulesTemplateUrl' => ($bIsBackend ? $sAddonThemeUrl : $sAddonTemplateUrl),
          'AddonTemplateUrl' => ($bIsBackend ? $sAddonThemeUrl : $sAddonTemplateUrl),
          'ADDON_URL'=> $sAddonUrl,
          'ModuleScript' => $sModule,
          ];

/**
 * Diese Zeilen nur aendern wenn du genau weisst was du tust!
 * '.' und '..' duerfen nicht entfernt werden!
 * Weitere invisibleFileNames koennen direkt im Backend der Foldergallery definiert werden.
 */
//Alle Ordner ausschliessen, welche zum Core von WB gehoeren
    $sPagesDir = \trim(PAGES_DIRECTORY, '/');
    $sAcpDir   = \trim(ADMIN_DIRECTORY, '/');
    $wbCoreFolders = [
        'account',
        $sAcpDir,
        'framework',
        'include',
        'install',
        'languages',
        'modules',
        (empty($sPagesDir) ? 'pages' : $sPagesDir),
        'search',
        'temp',
//        $thumbDirName,
        'templates',
        'logs',
        'var',
    ];
    $megapixel_limit = 5000*1024; //Ab dieser groesse wird kein Thumb mehr erzeugt.

// end of file