---
home: true
actionText: Get Started →
actionLink: /guide/
features:
- title: 100% Pure Javascript
  details: All vanilla with no dependencies, or use official wrappers
   for the component framework of your choice
- title: Responsive
  details: Interface will automatically resize if the image size changes
   because of responsive CSS rules.
- title: Touch Support
  details: Touch support tested with Android, iOS, and Chromebook. Mouse and
   touch are simultaneous and automatic.
- title: Multiple Crops
  details: Single cropping widgets are so boring
   widgets on the same stage are the doorway to advanced interfaces.
- title: Clean open source
  details: Webpack'd for your convenience, the full source code is
   open, easy to develop with, and MIT licensed.
- title: Advanced Control
  details: Create complex interactivity that transcends mere
   cropping using the well-documented API.
footer: MIT Licensed | Copyright © 2008-2018 Tapmodo Interactive LLC
---

# Purpose

# Features

  * Easily attach to any DOM element unobtrusively
  * Uses native events to coordinate behaviors
  * Crop elements can be constrained to a given ratio
  * Clean, commented source code
  * Full in-depth documentation
  * Keyboard support for arrow keys, deletion
  * Touch support for tablets and mobile

## Jcrop Guide

  * [Getting Started](/guide/)
  * [Using the documentation](/guide/about.html)
  * [The Jcrop Instance](/guide/instance.html)
  * [Options and Configuration](/guide/options.html)
  * [Event Handling](/guide/events.html)
  * [Styling and CSS](/guide/styling.html)
  * [Extending Jcrop](/guide/extend.html)
  * [Design Guide](/guide/design.html)

## Internal Objects

  * [`Rect`](/objects/rect.html)
  * [`DomObj`](/objects/domobj.html)
  * [`ConfObj`](/objects/confobj.html)
