<?php

use bin\{WbAdaptor,SecureTokens,Sanitize};
use bin\helpers\{PreCheck};

// prevent this file from being accessed directly
/* -------------------------------------------------------- */
// Must include code to prevent this file from being accessed directly
if (!\defined('SYSTEM_RUN')) {\header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found'); echo '404 Not Found'; flush(); exit; }
/* -------------------------------------------------------- */

/*******************************************************************************
 *
 * Update from Version 1.17 and higher to newest Versions
 *
 * new Settings Table
 * new Thumbnail-Settings
 * categorie text field now as text
 * delete unused files (many of them are moved to the admin folder)
 *
 ******************************************************************************/

/*
 * BEGIN: Create new settings table
 */

    $sAddonPath = str_replace('\\','/',__DIR__).'/';
    $sAddonName = \basename($sAddonPath);
    $aMsg = [];
    $sMsg = '';
    $iErr = false;
    $bLoaded = null;

try {
    $oReg = WbAdaptor::getInstance();
/**
 * change update.fixed to update
 * if any template or javascript fixed in templates/default/ folder
 */
     $sTemplateFile = 'none';
     $sUpgradeFile = $sAddonPath.'update';
     $isUpgradeFile = $sUpgradeFile.'.fixed';
     if (\is_readable($sUpgradeFile)){
        if (!\rename($sUpgradeFile, $sUpgradeFile.'.fixed')){
            echo $sMsg = \sprintf('renaming of %s %s <br />',\basename($sUpgradeFile.'.fixed'), 'FAILED');
        } elseif(!$isUpgradeFile) {
            $sTemplateFile = ($oReg->Template ?? 'none');
        }
    }

    if (\is_readable($sAddonPath.'init.php')) {require ($sAddonPath.'init.php');}
    // check if upgrade startet by upgrade-script to echo a message
    $globalStarted = \preg_match('/upgrade\-script\.php$/', $_SERVER["SCRIPT_NAME"]);
    $sWbVersion = ($globalStarted && \defined('VERSION') ? VERSION : WB_VERSION);
    Translate::getInstance()->enableAddon(ADMIN_DIRECTORY.'\\addons');
    if (\is_writable(WB_PATH.'/temp/cache')) {
        Translate::getInstance()->clearCache();
    }
    $aRequired['PHP'] = [
          'Addon'  => 'PHP',
          'version' => \PHP_VERSION,
          'required' => '7.4',
          'operator' => '>=',
          ];
    $sTmp   = PreCheck::getMissingRequirements($aRequired);
    if (!empty($sTmp)){$aMsg[] = $sTmp."\n";}
    if (!empty($aMsg)){
//        throw new \InvalidArgumentException(($aMsg));
    }
    unset($aRequired);
    $aRequired['PHP'] = [
          'Addon'  => 'WebsiteBaker',
          'version' => $sWbVersion,
          'required' => '2.13.0',
          'operator' => '>=',
          ];
    $sTmp   = PreCheck::getMissingRequirements($aRequired);
    if (!empty($sTmp)){$aMsg[] = $sTmp."\n";}
    if (!empty($aMsg)){
        $sMsg = ((\is_array($aMsg)) ? (\implode("\n",$aMsg)) : "unknown Error");
        throw new \InvalidArgumentException($sMsg);
    }
    unset($aRequired);


    $OK   = '<span class="ok">OK</span>';
    $FAIL = '<span class="error">FAILED</span>';
    $iErr = false;
    $sNameValPairs    = '';
    $bOldStructure    = false;
    $sAddonName       = \basename(__DIR__);
    $sTablePrefix      = $database->getTablePrefix();
//    $sTableName       = 'fg134_mod_foldergallery_settings';
    $sTableName       = $sTablePrefix.'mod_foldergallery_settings';
    $i = (!isset($i) ? 1 : $i);
    $sInstallStruct   = $sAddonPath.'/install-struct.sql.php';
    $sInstallUpdate   = $sAddonPath.'/install-upgrade.sql.php';

//    $dbName           = DB_NAME;
    $iErr = false;
    $aSettings        = [];
    $aNewSettings     = [];
    $aOldSettings     = [];
    $aDefaultSettings = [];
    if (\is_readable($sAddonPath.'/presets/thumbPresets.php')){require($sAddonPath.'/presets/thumbPresets.php');}

    if (!\is_readable($sInstallUpdate)) {
        $aMsg[] = sprintf("<strong>missing or not readable file [install-upgrade.sql]</strong> %s\n",$FAIL);
        $iErr = true;
    } else {
        $sTableName = TABLE_PREFIX.'mod_foldergallery_settings';
        // get settings from table and return an array otherwise false
        $selectSettings = (function() use ($database, $sTableName) {
            $aSettings =  [];
            $sql = 'SELECT * FROM `'.$sTableName.'`';
            if ($oRes = $database->query($sql)){
                $aSettings = $oRes->fetchAll(MYSQLI_ASSOC);
            }
            return ((\count($aSettings) > 0) ? $aSettings : false);
        });

// prepare an array to create the sql statement
        $prepareSettings = (function($aOldSettings) use ($MediaRel,$aDefaults)
        {
            $i=0;
            $y=1;
            $iSectionId = 0;
            $aInvisibile = \explode(',',$aDefaults['invisible']);
            $iSectionId = $aOldSettings[$i]['section_id'];
            $aTmpSettings = [];
            $aTmpSettings[$i]['section_id'] = $iSectionId;
            foreach ($aOldSettings as $aSettings) {
                $sIndexName =  $aSettings['s_name'];
                $sValue     =  $aSettings['s_value'];
                $sValue     = ($sIndexName=='root_dir' ? \str_replace($MediaRel, '', $sValue) : $sValue);
                $bChangeSection = ($iSectionId !== $aSettings['section_id']);
                if ($bChangeSection){
                    $i++;
                    $y = 1;
                    $iSectionId =  $aSettings['section_id'];
                    $aTmpSettings[$i]['section_id'] = $iSectionId;
                    $aTmpSettings[$i][$sIndexName] = $sValue;
                } else {
                    $aTmpSettings[$i][$sIndexName] = $sValue;
                    if ($sIndexName == 'invisible'){
                        $aForbidden['invisible'] = \array_diff($aInvisibile, \explode(',',$aTmpSettings[$i]['invisible']));
                        $sForbidden = ','.\implode(",",$aForbidden['invisible']);
                        $aTmpSettings[$i]['invisible'] = \trim($aTmpSettings[$i]['invisible'].$sForbidden,',');
                    }
                }
                $y++;
            }
            return ((\count($aTmpSettings) > 0) ? $aTmpSettings : false);
        });

        // try to create table if not exists
        $database->SqlImport($sInstallStruct, $sTablePrefix, true );
        // read settings first
        $sql = 'SELECT * FROM `'.$sTableName.'`';
        // check if table already upgraded
        if ($bOldStructure = $database->field_exists($sTableName, 'page_id'))
        {
            if (!($aOldSettings = $selectSettings()))
            {
                $aMsg[] = sprintf("[%03d]<strong>Folder Gallery backup old settings</strong> %s",__LINE__,$FAIL );
                $iErr = true;
            }
            $i=0;
            for ($i=0; $i < \count($aOldSettings); $i++){
                $aOldSettings[$i]['root_dir'] = \str_replace($MediaRel, '', $aOldSettings[$i]['root_dir']);
            }
        } elseif ($database->field_exists($sTableName, 'id'))
        {
            if (!($aOldSettings = $selectSettings()))
            {
                $aMsg[] = sprintf("[%03d]  <strong>Folder Gallery backup old settings</strong> %s",__LINE__,$FAIL );
                $iErr = true;
            } else {
                $aTmp = $aOldSettings;
                $i=0;
                $aOldSettings = [];
// firstremove id
                foreach ($aTmp as $key=>$aValue){
                    $del = \array_shift($aValue);
                    $aOldSettings[$key] = $aValue;
                }
                // prepare an array to create the sql statement
                $aOldSettings = $prepareSettings($aOldSettings);
            }
        } elseif ($database->field_exists($sTableName, 's_name'))
        {
            // overwrite standardsettings ($aOldSettings)
            if (!($aOldSettings = $selectSettings()))
            {
                $aMsg[] = sprintf("[%03d] <strong>FolderGallery has no old settings</strong> %s",__LINE__,$FAIL );
                $iErr = true;
            } else {
                // prepare an array to create the sql statement
                $aOldSettings = $prepareSettings($aOldSettings);
            }
        } // end handling new structure

        if ($database->index_exists($sTableName,'indent_foldergallery')){$database->index_remove($sTableName,'indent_foldergallery');}
       // delete none allowed entries in settings.s_name
        $aSettingsDenied = ['s_name','s_value']; //'section_id',
        // drop old table and create new one  ident_foldergallery
        if ((\count($aOldSettings)
            && !$iErr && \count($aDefaults))
            && $database->SqlImport($sInstallUpdate, $sTablePrefix, false) //$sInstallUpdate
            ) {
           // restore old settings if there any
            if ($aOldSettings && !$iErr)
            {
                $iSectionId = 0;

                foreach ($aOldSettings as $aItems) {
                    // add new default settings
                    $aSettings  = \array_merge( $aDefaults, $aItems );//replace_recursive

                    $iSectionId = $aSettings['section_id'];
                    // update sections modulename if changed with same table structure
                    $sqlSection = 'UPDATE `'.$sTablePrefix.'sections` SET '
                                . '`module` = \''.$sAddonName.'\' '
                                . 'WHERE `section_id` = '.$iSectionId.';';
                    if (!$database->query($sqlSection)){
                          $aMsg[] = sprintf("[%03d] <strong>Database error table sections  %s</strong>",__LINE__,$database->get_error() );
                          $aMsg[] = sprintf("[%03d] <strong>Folder Gallery couldn\'t change sections entry ID %s</strong> %s",__LINE__,$iSectionId, $FAIL );

                        }

                    $sNameValPairs = '';
// insert settings per section
                    foreach ($aSettings as $index => $val) {
                        if (\in_array($index, $aSettingsDenied) ) { continue; }

                        $sNameValPairs .= ','."\n".' ('.$iSectionId.', \''.$index.'\', \''.$database->escapeString($val).'\')';
//echo nl2br(sprintf("<div class='w3-white w3-border w3-padding'>[%03d] %s</div>\n",__LINE__, $sNameValPairs));
                    }
                    $sValues = \ltrim($sNameValPairs, ', ');
                    $sTableName = $sTablePrefix.'mod_foldergallery_settings';
                    $sql = 'INSERT INTO `'.$sTableName.'` (`section_id`, `s_name`, `s_value`) '
                         . 'VALUES '.$sValues.';';
                    if (!$database->query($sql)) {
//                        $aMsg[] = $database->get_error().'<br />';
//                        $aMsg[] = '<strong>\'Folder Gallery INSERT INTO (restore) old settings\'</strong> '.$FAIL.'<br />';
                          $aMsg[] = sprintf("[%03d] <strong>Database error table settings %s</strong>",__LINE__,$database->get_error() );
                          $aMsg[] = sprintf("[%03d] <strong>Folder Gallery INSERT INTO (restore) old settings</strong> %s",__LINE__,$FAIL );
                          $iErr = true;
                    }
                }  // end for settings per section

                $sSqlUpdate = '
                UPDATE `'.$sTablePrefix.'mod_foldergallery_files` `files`
                        INNER JOIN `'.$sTablePrefix.'mod_foldergallery_categories` `cat`
                             ON `cat`.`id` = `files`.`parent_id`
                SET `files`.`section_id` = `cat`.`section_id`
                WHERE `files`.`section_id` = 0
                ';
               if (!($database->query($sSqlUpdate))){
//                  $aMsg[] = $database->get_error().'<br />';
//                  $aMsg[] = '<strong>\'Folder Gallery recreate files table\'</strong> '.$FAIL.'<br />';
                  $aMsg[] = sprintf("[%03d] <strong>Database error table categories  %s</strong>",__LINE__,$database->get_error() );
                  $aMsg[] = sprintf("[%03d] <strong>Folder Gallery recreate files table</strong> %s",__LINE__,$FAIL );
                  $iErr = true;
               }
                $sSqlUpdate = '
                UPDATE `'.$sTablePrefix.'mod_foldergallery_settings` `st`
                SET `st`.`s_value` = \''.$database->escapeString($aDefaults['invisible']).'\'
                WHERE `st`.`s_name` = \'invisible\'
                  AND `st`.`s_value` = \'\'
                ';
               if (!($database->query($sSqlUpdate))){
                  $aMsg[] = sprintf("[%03d] <strong>Database error table settings  %s</strong>",__LINE__,$database->get_error() );
                  $aMsg[] = sprintf("[%03d] <strong>Folder Gallery recreate settings table</strong> %s",__LINE__,$FAIL );
                  $iErr = true;
               }
            }
            if ($database->is_error()){
                $aMsg[] = sprintf("[%03d] <strong>Database error table settings  %s</strong> %s",__LINE__,$database->get_error(),'' );
                $aMsg[] = sprintf("[%03d] <strong>Folder Gallery recreate settings table</strong> %s",__LINE__,$FAIL );
                $iErr = true;
            }
        } else {
            $aMsg[] = sprintf("[%03d] <strong>Database error table settings  %s</strong> %s",__LINE__,$database->get_error(),'' );
            $aMsg[] = sprintf("[%03d] <strong>Folder Gallery sqlImport</strong> %s",__LINE__,$FAIL );
            $iErr = true;
        }
        if (!$iErr) {
            $aMsg[] = sprintf("[%03d] <strong>Folder Gallery successful updated</strong> %s",__LINE__,$OK );
        } else {
//            $aMsg[] = '<strong>\'Folder Gallery couldn\'t updated\'</strong> '.$FAIL.'<br />';
            $aMsg[] = sprintf("[%03d] <strong>Folder Gallery couldn't updated</strong> %s",__LINE__,$FAIL );
        }
//        unset($getSettings);
    }
/*--------------------------------------------------------------------------------------------------*/
/**
 * There are files which are moved or no longer needed.
 * So we need to delete the old files and directories
 */
/*--------------------------------------------------------------------------------------------------*/

    $aRemoveList = [
                '/modify_cat.php',
                '/modify_cat_sort.php',
                '/modify_settings.php',
                '/modify_thumb.php',
                '/save_cat.ph',
                '/save_files.php',
                '/save_settings.php',
                '/sync.php',
                '/frontend.css.orig',
                '/install-struct.sql',
                '/install-upgrade.sql',

                '/class/DirectoryHandler.Class.php',
                '/class/class.upload.php',
                '/class/index.php',

                '/scripts/backend.functions.ph',
                '/scripts/delete_cat.php',
                '/scripts/delete_img.php',
                '/scripts/move_down.php',
                '/scripts/move_up.php',
                '/scripts/quick_img_sort.php',
                '/scripts/reorderCNC.php',
                '/scripts/reorderDND.php',

                '/templates/Unbenannt1.html',
                '/templates/modify_cat.htt',
                '/templates/modify_cat_sort.htt',
                '/templates/modify_settings.htt',
                '/templates/modify.htt',

                '/templates/index.php',
                '/templates/view.htt',
                '/templates/view_colorbox.htt',
                '/templates/view_colorboxSnippet.htt',
                '/templates/view_contentFlow.htt',
                '/templates/view_galleryview.htt',
                '/templates/view_highslider.htt',
                '/templates/view_jqueryFancybox.htt',
                '/templates/view_jqueryLightbox.htt',
                '/templates/view_shutter.htt',
                '/templates/view_zoomimage.htt',
                '/templates/'.$sTemplateFile.'/',
                '/templates/DefaultTemplateHgs/',
                '/templates/DefaultTemplate/',
                '/templates/fotilo/',
                '/templates/fruesteg/',
                '/templates/ResponsiveTemplate/',
                '/templates/WebsiteBakerOrg/',
                '/templates/view_ad_gallery.htt',
                '/templates/view_galleryview30.htt',
                '/templates/view_pirobox.htt',
                '/templates/view_prettyphoto.htt',

                '/templates/default/view_old_galleryview.htt',
                '/templates/default/view_responsiveLightboxCaption.htt',
                '/templates/default/view_colorboxCaption.htt',
                '/templates/default/view_jqueryFancyboxCaption.htt',
                '/templates/default/view_magnific_popupCaption.htt',

                '/themes/default/FineUpload/fine-uploader.js',
                '/themes/default/FineUpload/jquery.fine-uploader.js',

                '/images/eck.gif',
                '/images/crumbs.gif',
              ];
            PreCheck::deleteFiles($sAddonPath,$aRemoveList);

    $bLoaded = !\count($aMsg);

    unset($aExistingFiles);
/*--------------------------------------------------------------------------------------------------*/
    } catch (\Throwable $ex) {
        /* place to insert different error/logfile messages */
        $aMsg = (\sprintf('[%d] %s', $ex->getLine(), $ex->getMessage()));
    }
//      $sMsg = \sprintf(\implode("\n",$aMsg))."\n";
    $sMsg = ((\is_array($aMsg) && count($aMsg)) ? \sprintf(\implode("\n",$aMsg)) : "")."\n";
    if (\is_array($aMsg) && !empty($aMsg) && $iErr){
        echo nl2br(sprintf("<div class='w3-white w3-border w3-padding'>[%03d] %s</div>\n",__LINE__, $sMsg));
    }
/* */
    if (!$iErr){unset($sMsg);}
    if ($globalStarted) {
//        print Message for upgrade-script
    }

// end of file
