<?php
/**
 *
 */

use bin\{WbAdaptor,SecureTokens,Sanitize};
use bin\helpers\{PreCheck,msgQueue,ParentList};
use src\Security\{CsfrTokens,Randomizer};
use src\Interfaces\Requester;
use bin\Requester\HttpRequester;
use vendor\pclzip\PclZip;
use vendor\phplib\Template;

/* -------------------------------------------------------- */
// Must include code to prevent this file from being accessed directly
if (!\defined('SYSTEM_RUN')) {\header($_SERVER['SERVER_PROTOCOL'].' 404 Not Found'); echo '404 Not Found'; \flush(); exit;}
/* -------------------------------------------------------- */

    $sAddonPath = str_replace('\\','/',__DIR__).'/';
    if (\is_readable($sAddonPath.'init.php')) {require ($sAddonPath.'init.php');}
    if (\is_readable($sAddonPath.'presets/thumbPresets.php')){require($sAddonPath.'presets/thumbPresets.php');}
    // An associative array that by default contains the contents of $aRequestVars, $aRequestVars and $_COOKIE.
    if (empty($aRequestVars)){
        $aRequestVars = [];
        $aVars = $oRequest->getParamNames();
        foreach ($aVars as $sName) {
            $aRequestVars[$sName] = $oRequest->getParam($sName);
        }
    }
    $oReg = WbAdaptor::getInstance();
    $oDb  = $oReg->getDatabase();
    $oApp = $oReg->getApplication();
    $wb   = $oApp;
    $database = $oDb;
    $sTablePrefix = $oDb->getTablePrefix();
    $generatethumbscounter = 0;
    $validator = new Validator();
//    $wb->ami_group_member($wb->get_groups_id());
    $isEmpty = false;
    $bIsAdmin = ($wb->is_authenticated() && $wb->ami_group_member('1'));
try {

    if (!hasCategories($section_id)){
        $sMessage = sprintf('Missing Categorie for section %s',$section_id);
        throw new \Exception ($sMessage);
    }

    $settings = getFGSettings($section_id); //FG_getAdvancedThumbSettings

    $sLoadPresets = $settings['loadPreset'];
    $aLoadPresets['ratio'] = $thumbPresets[$sLoadPresets];

    $aW3Advanced = array_diff_key($settings['tbSettings'],$aThumbSettings);
    $aW3Advanced['timer'] = ($aW3Advanced['timer'] ?? 8000);

//    $root_dir = MEDIA_DIRECTORY.$settings['root_dir']; //Chio
    $title = '';
    if (!isset($settings['root_dir'])) {
        throw new \Exception ( $MOD_FOLDERGALLERY['FRONT_END_ERROR']);
    }
    $root_dir = $MediaRel.$settings['root_dir'];
    $folder = $root_dir.'/';

    $catpic = (int) $settings['catpic']; //Chio
    // Get page-link from database
    $sPageLinkUrl = $link = $oApp->getPageLink($page_id);
    $sPaginationStyle = (isset($settings['pagination']) && ($settings['pagination']!='')?$settings['pagination']:'NewYahooStyle');
    $path = $oReg->AppPath;
    $ergebnisse = [];  // Da drin werden dann alle Ergebnisse aus der DB gespeichert
    $unterKats  = [];  // Hier rein kommen die Unterkategorien der aktuellen Kategorie
    $bilder     = [];  // hier kommen alle Bilder der aktuellen Kategorie rein
    $NoImages   = false;
    $NoCategory = false;
// Ist die angegebene Kategorie gueltig? (erlaubter String)
    $aktuelleKat = '';
    $FG_Error['CatNotValid'] = false;
    $sQueryCat = (isset($aRequestVars['cat']) ? $aRequestVars['cat'] : null);
    $iQuerySectionId = (isset($aRequestVars['section_id']) ? $aRequestVars['section_id'] : 0);
    if ($sQueryCat  && ($iQuerySectionId==$section_id)) {
        $aktuelleKat = \urldecode($sQueryCat);
        $aktuelleKat = FG_cleanCat(\urldecode($sQueryCat));
    } else {
        $FG_Error['CatNotValid'] = true;
    }

// Die Kategorie ID wird erst fuer die Bilder gebraucht!
// Jedoch laesst sich so einfach feststellen ob eine Kategorie vorhanden ist
    try {
        $aktuelleKat_id = FG_getCatId($section_id, $aktuelleKat);
        $FG_Error['CatNotValid'] = false;
    } catch (Exception $e) {
//        $aktuelleKat = '';
        $aktuelleKat_id = FG_getCatId($section_id, $aktuelleKat);
        $FG_Error['CatNotValid'] = true;
    }
    if (!$aktuelleKat_id) {
        throw new \Exception ( $MOD_FOLDERGALLERY['NO_FILES_IN_CAT']);
    }

    //SQL fuer die Kategorien
//          .  'AND `is_empty` = 0
    $aSql[1] = '
    SELECT * FROM `'.$sTablePrefix.'mod_foldergallery_categories`
    WHERE `section_id` ='.$section_id.'
      AND `parent` = \''.$aktuelleKat.'\'
      AND `active` = 1
    ORDER BY `position`
    ';
    if ($query = $database->query($aSql[1])) {
        while (($ergebnis = $query->fetchRow(MYSQLI_ASSOC))) { // !is_null
            $ergebnisse[] = $ergebnis;
       }
    }

    if (empty($ergebnisse)) {
        $NoCategory = $error['NoImages'] = true;
    } else {
        // Vorschaubild auswaehlen:
        switch ($catpic) {
            case 1:
                $catpicstring = '`position` ASC';
                break;
            case 2:
                $catpicstring = '`position` DESC';
                break;
            default :
                $catpicstring = 'RAND()';
        }
        $aErrorMsg = [];

/* show ergebnisse in cats */
        foreach ($ergebnisse as $key => $ergebnis)
        {
            $catCrumb = $ergebnis['parent'].'/'.$ergebnis['categorie'];
            $catLink = $link.'?cat='.$catCrumb.'&amp;section_id='.$section_id;
            $catName = $ergebnis['cat_name'];
            $catID = $ergebnis['id'];
            $tmpChilds = trim($ergebnis['childs']);
            $catChilds = ($tmpChilds ? ','.trim($ergebnis['childs'], ',') : $tmpChilds);
            // OK, lets find a preview Image for this categorie
            #echo " Cat-ID = ".$catID."<br>";
            //search undercats of this categorie
            $aSql[2] = '
            SELECT `file_name`, `id`, `parent_id` FROM
            `'.$sTablePrefix.'mod_foldergallery_files`
            WHERE `parent_id` ='.$catID.'
            ORDER BY '.$catpicstring.'
            ';
            if (!$query = $database->query($aSql[2])){
              $aErrorMsg[] = $database->get_error();
            }
            $imageID = 0;
            $imageParentID = $imageID;
            $imageName = '';
            if ( ($iCatNumrow = $query->numRows()) == 0) {
    // Categorie itself contains no images, search for files in childs of this categorie
                $aSql[3] = '
                SELECT
                `file_name`, `id`, `parent_id`
                FROM `'.$sTablePrefix.'mod_foldergallery_files`
                WHERE `parent_id` IN ('.$catID.$catChilds.')
                ORDER BY `parent_id` ASC, '.$catpicstring.'
                ';
                if (!$query = $database->query($aSql[3])){
                    $aErrorMsg[] = $database->get_error();
                  }
            }
            if (($imageData = $query->fetchRow(MYSQLI_ASSOC))){//!is_null
                $imageID = $imageData['id'];
                $imageName = $imageData['file_name'];
                $imageParentID = intval($imageData['parent_id']);
            }
            $title = $oReg->PageTitle;   // Page title of the actual page (WB Core)
            $imageCrumb = $root_dir.$catCrumb;
            if ($imageParentID != $catID) {
                // OK, its a image of a subcat, so we need the folder of this cat
                $aSql[4] = '
                SELECT `id`, `parent`, `categorie` FROM
                `'.$sTablePrefix.'mod_foldergallery_categories`
                WHERE `id` ='.$imageParentID.'
                AND `active` = 1
                ';
                if ($query = $database->query($aSql[4])){
                    if (($result = $query->fetchRow(MYSQLI_ASSOC))){// !is_null
                      $imageCrumb = $root_dir.$result['parent'].'/'.$result['categorie'];
                    }
               }
            }
//  Preview image in a categorie
            $NoImages       = empty($imageName);
            $image_name     = ($bIsAdmin ? 'unknown_img.png' : '');
            $imagePath      = ($sAddonThemePath.'/img/'.$image_name ?? '');
            $thumbPathDir   = ''; #.$sAddonThemeRel.'/img/';
            $thumbImagePath = ($bIsAdmin ? $thumbPathDir.$image_name : '');
            $thumbImageURL  = ($bIsAdmin ? $sAddonThemeUrl.'img/'.$image_name : '');
            unset($image_name);

            if (!$NoImages){
            // Create the thumb for a categorie
                $imagePath      = $oReg->AppPath.$imageCrumb.'/'.$imageName;
                $thumbPathDir   = $oReg->AppPath.$imageCrumb.$settings['thumbPath'].'/';
                $thumbImagePath = $thumbPathDir.$imageName;
                $thumbImageURL  = $oReg->AppUrl.$imageCrumb.$settings['thumbPath'].'/'.$imageName;
            }
            $sImagePattern = '/.*?(unknown_).*?/is';
            $sPathName     = DirectoryHandler::DecodePath($imagePath);
            $bIsImage      = ((preg_match($sImagePattern, $imagePath)) ? $bIsAdmin : false);
            $bCreateThumb  = ((is_file($sPathName) && $bIsImage) ? true : false);
            $bIsThumbAdm   = ((!$bCreateThumb) ? true : false);

// create categorie thumbs
            if ((($bCreateThumb && $bIsImage) || ($bIsThumbAdm && ($thumbPathDir)))) {
                FG_createThumb($imagePath, $imageName, $thumbPathDir, $settings['tbSettings']);
            // Create a array for the template
                $unterKats[] = [
                    'cat_id' => $ergebnis['id'],
                    'link' => $catLink,
                    'thumb' => $thumbImageURL,
                    'name' => $catName,
                    'parent_id' => $catID
                ];
            }
            else
            if (preg_match($sImagePattern, $thumbImageURL, $aMatches)){
                $unterKats[] = [
                    'cat_id' => 0,
                    'link' => '',
                    'thumb' => '',
                    'name' => '',
                    'parent_id' => 0
                ];
            }
        } // end of foreach $ergebnisse

        if (sizeof($aErrorMsg)){
            echo implode('<br />', $aErrorMsg);
        }
    }

// check for existing images in this categorie. count the images and return images data
//    $bilder = [];
    $aSql[5] = '
    SELECT * FROM `'.$sTablePrefix.'mod_foldergallery_files`
    WHERE `parent_id`= '. $aktuelleKat_id.'
    ORDER BY `position` ASC
    ';
    if ($query = $database->query($aSql[5])){
        while (($bild = $query->fetchRow(MYSQLI_ASSOC))) { // !is_null
//        if ($bild['file_name'] == 'folderpreview.jpg'){continue;}
            $bilder[] = $bild;
        }
    }
    $aTmp = [
          'id' => 0,
          'section_id' => $section_id,
          'active' => 1,
          'parent_id' => $aktuelleKat_id,
          'file_name' => '',
          'position' => 0,
          'caption' => '',
          'img_title' => '',
    ];

//  && !$NoCategory && $NoImages
    if ($bIsAdmin && empty($bilder))
    {
        $aTmp = [
              'id' => 0,
              'section_id' => $section_id,
              'active' => 1,
              'parent_id' => $aktuelleKat_id,
              'file_name' => 'unknown_img.png',
              'position' => 0,
              'caption' => '',
              'img_title' => '',
        ];
//    add unknown_img.png if no images found and you are admin
        $bilder[] = $aTmp;
    }
    $title = '';
    $description = '';

    if (!empty($bilder))
    {
        $error = false;
        $temp = explode('/', $aktuelleKat);
        $bildkat = array_pop($temp);
        $bildparent = implode('/', $temp);
        $aSql[6] = '
        SELECT * FROM `'.$sTablePrefix.'mod_foldergallery_categories`
        WHERE `section_id` = '.$section_id.'
          AND `categorie` = \''.$bildkat.'\'
          AND `parent` = \''.$bildparent.'\'
          AND `active` = 1
        ';
        $result = [];
        if ($query = $database->query($aSql[6])){
            if (($result = $query->fetchRow(MYSQLI_ASSOC))){// !is_null
                $title = $result['cat_name'];
                $description = ($aW3Advanced['description'] ?? $result['description']);
                $folder = $root_dir.$result['parent'].'/';
            }
        }
//echo nl2br(sprintf("<div class='w3-white w3-border w3-padding'>[%03d] %s</div>\n",__LINE__, $description));
        if (!empty($result['categorie'])){
            $folder .= $result['categorie'].'/';
        }
//        $pathToFolder = $folder.'/';
        $pathToFolder = $folder;
//        $pathToThumb  = $oReg->AppPath.$folder.$thumbDirName;
//        $urlToFolder  = $url.$folder;
        $urlToThumb   = $url.$folder.$thumbDirName.'/';
        $aSql[7] = '
        SELECT `cat_name`,`description` FROM `'.$sTablePrefix.'mod_foldergallery_categories`
        WHERE `section_id` = '.$section_id.'
          AND `id` = '.$aktuelleKat_id.'
          AND `active` = 1
        ';
        if ($query = $database->query($aSql[7])){
            if (($result = $query->fetchRow(MYSQLI_ASSOC))){
                $description = ($aW3Advanced['description'] ?? $result['description']);
                $title = $result['cat_name'];
            }
        }
    } else {
        $aSql[8] = '
        SELECT `cat_name`,`description` FROM `'.$sTablePrefix.'mod_foldergallery_categories`
        WHERE `section_id` = '.$section_id.'
          AND `id` = '.$aktuelleKat_id.'
          AND `active` = 1
        ';
        if ($query = $database->query($aSql[8])){
            if (($result = $query->fetchRow(MYSQLI_ASSOC))){
                $description = ($aW3Advanced['description'] ?? $result['description']);
                $title = $result['cat_name'];
            }
        }
    }
// backlink in breadcrumb
    if ($aktuelleKat) {
        $temp = explode('/', $aktuelleKat);
        array_pop($temp);
        $parent = implode('/', $temp);
        $back_link = $link.'?cat='.$parent.'&amp;section_id='.$section_id;
        $hidden = '';
    } else {
        $hidden = 'style="display:none"';
        $back_link = '#';
    }

    $aTmp = [
          'id' => 0,
          'section_id' => $section_id,
          'active' => 1,
          'parent_id' => $aktuelleKat_id,
          'file_name' => '',
          'position' => 0,
          'caption' => '',
          'img_title' => '',
    ];
//  && !$NoCategory && $NoImages
    if ($bIsAdmin && empty($bilder))
    {
        $aTmp = [
              'id' => 0,
              'section_id' => $section_id,
              'active' => 1,
              'parent_id' => $aktuelleKat_id,
              'file_name' => 'unknown_img.png',
              'position' => 0,
              'caption' => '',
              'img_title' => '',
        ];
        $bilder[] = $aTmp;
    }
//echo '<h1>'.$aktuelleKat_id.'</h1>';
//    $title = '';
//    $description = '';
//    $pathToFolder = $folder;

    if (!empty($bilder))
    {
        $error = false;
        $temp = explode('/', $aktuelleKat);
        $bildkat = array_pop($temp);
        $bildparent = implode('/', $temp);
        $aSql[9] = '
        SELECT * FROM `'.$sTablePrefix.'mod_foldergallery_categories`
        WHERE `section_id` = '.$section_id.'
          AND `categorie` = \''.$bildkat.'\'
          AND `parent` = \''.$bildparent.'\'
          AND `active` = 1
        ';
        if (($query = $database->query($aSql[9]))){
            if (($result = $query->fetchRow(MYSQLI_ASSOC))){// !is_null
                $title = $result['cat_name'];
                $description = ($aW3Advanced['description'] ?? $result['description']);
                $folder = $root_dir.$result['parent'].'/';
            }
        }
//echo nl2br(sprintf("<div class='w3-white w3-border w3-padding'>[%03d] %s</div>\n",__LINE__, $description));
        if (!empty($result['categorie'])){
            $folder .= $result['categorie'].'/';
        }

//        $pathToThumb  = $oReg->AppPath.$folder.$thumbDirName;
//        $urlToFolder  = $url.$folder;
        $urlToThumb   = $url.$folder.$thumbDirName.'/';
        $result = [];
        $description  = '';
        $title        = '';
        $aSql[10] = '
        SELECT `cat_name`,`description` FROM `'.$sTablePrefix.'mod_foldergallery_categories`
        WHERE `section_id` = '.$section_id.'
          AND `id` = '.$aktuelleKat_id.'
          AND `active` = 1
        ';
        $query = $database->query($aSql[10]);
        if (($result = $query->fetchRow(MYSQLI_ASSOC))){
          $description = ($aW3Advanced['description'] ?? $result['description']);
          $title = $result['cat_name'];
        }
    } else {
        $aSql[11] = '
        SELECT `cat_name`,`description` FROM `'.$sTablePrefix.'mod_foldergallery_categories`
        WHERE `section_id` = '.$section_id.'
          AND `id` = '.$aktuelleKat_id.'
          AND `active` = 1
        ';
        $query  = $database->query($aSql[11]);
        if (($result = $query->fetchRow(MYSQLI_ASSOC))){
            $title  = $result['cat_name'];
            $description = ($aW3Advanced['description'] ?? $result['description']);
        }
    }
// backlink
    if ($aktuelleKat) {
        $temp = explode('/', $aktuelleKat);
        array_pop($temp);
        $parent = implode('/', $temp);
        $back_link = $link.'?cat='.$parent.'&amp;section_id='.$section_id;
        $hidden = '';
    } else {
        $hidden = 'style="display:none"';
        $back_link = '#';
    }
// set Template
    $settings['lightbox'] = ($settings['lightbox']==''?'Colorbox':$settings['lightbox']);
    if (is_readable($sAddonTemplatePath.'/view_'.$settings['lightbox'].'.htt')) {
        $viewTemplate = 'view_'.$settings['lightbox'].'.htt';
        $tpl = new Template($sAddonTemplatePath, 'remove');
    } elseif (is_readable($oReg->AppPath.'/modules/'.$settings['lightbox'].'/foldergallery_template.htt')) {
        $viewTemplate = 'foldergallery_template.htt';
        $tpl = new Template($oReg->AppPath.'/modules/'.$settings['lightbox'], 'remove');
        $parts = explode('/', $settings['lightbox']);
        echo "[[LibInclude?lib=".$parts[0]."&amp;plugin=".$parts[2]."]]";
    } elseif (is_readable($oReg->AppPath.'/modules/jqueryadmin/plugins/'.$settings['lightbox'].'/foldergallery_template.htt')) {
        $viewTemplate = 'foldergallery_template.htt';
        $tpl = new Template($oReg->AppPath.'/modules/jqueryadmin/plugins/'.$settings['lightbox'], 'remove');
        echo "[[jQueryInclude?plugin=".$settings['lightbox']."]]";
    } else {
        $viewTemplate = 'view.htt';
// --- added by WebBird, 29.07.2010 ---
        $tpl = new Template($sAddonTemplatePath);
// --- end added by WebBird, 29.07.2010 ---
    }
// --- commented by WebBird, 29.07.2010 ---
    $tpl->halt_on_error = 'yes';
   /**
    * Determines how much debugging output Template will produce.
    * This is a bitwise mask of available debug levels:
    * 0 = no debugging
    * 1 = debug variable assignments
    * 2 = debug calls to get variable
    * 4 = debug internals (outputs all function calls with parameters).
    * 8 = debug (outputs all set_block variables calls with parameters).
    *
    * Note: setting $this->debug = true will enable debugging of variable
    *
    */
    $tpl->setDebug(0);
    $tpl->set_file('view', $viewTemplate);
    $tpl->set_block('view', 'main_block', 'main');
    $tpl->set_block('main_block', 'CommentDoc', 'COMMENTDOC');
    $tpl->clear_var('CommentDoc');
    $tpl->set_block('main_block', 'error_block', 'ERROR');  // Dieser Fehler wird nicht ausgegeben, BUG

    $tpl->set_block('main_block', 'show_breadcrumb_block', 'SHOW_BREADCRUMB');  // Dieser Fehler wird nicht ausgegeben, BUG

    $tpl->set_block('main_block', 'galimages', 'GALIMAGES');
    $tpl->set_block('galimages', 'galinvisiblePre', 'GALINVISIBLEPRE'); // Fuer weitere Bilder
    $tpl->set_block('galimages', 'galthumbnails', 'GALTHUMBNAILS');
    $tpl->set_block('galimages', 'galinvisiblePost', 'GALINVISIBLEPOST');

    $tpl->set_block('main_block', 'show_galnav_block', 'show_galnav');
    $tpl->set_block('show_galnav_block', 'list_galnav_block', 'list_galnav');

    $tpl->set_block('main_block', 'hr_block', 'HR');

    $tpl->set_block('main_block', 'show_images_block', 'IMAGES');
    $tpl->set_block('show_images_block', 'list_images_block', 'list_images');
    $tpl->set_block('list_images_block', 'show_caption_block', 'show_caption');
    $tpl->set_block('show_images_block', 'invisiblePre', 'INVISIBLEPRE'); // Fuer weitere Bilder
    $tpl->set_block('show_images_block', 'show_thumbnails_block', 'THUMBNAILS');
    $tpl->set_block('show_images_block', 'invisiblePost', 'INVISIBLEPOST');

    $tpl->set_block('main_block', 'show_pagenav_block', 'show_pagenav');
    $tpl->set_block('show_pagenav_block', 'list_pagenav_block', 'list_pagenav');
/*
    $tpl->set_block('main_block', 'categories', 'CATEGORIES');
    $tpl->set_block('categories', 'show_categories', 'SHOW_CATEGORIES');
*/
    $tpl->set_var('$oReg->AppUrl', $oReg->AppUrl);

    $tpl->set_var($aTplDefaults);

    $tpl->set_var('PAGINATIONCSS', $sPaginationStyle);

// As the error reporting is not implemented in the frontend, set error to false
    $error = false;
    if ($error) {
        $tpl->set_var('FRONT_END_ERROR_STRING', $MOD_FOLDERGALLERY['FRONT_END_ERROR']);
        $tpl->parse('ERROR', 'error_block');
    } else {
        $tpl->clear_var('error');
    }
    $tpl->set_var(\Translate::getInstance()->getLangArray());
    $tpl->set_var([
        'VIEW_TITLE' => $title,
        'BACK_LINK' => $back_link,
        'BACK_STRING' => $MOD_FOLDERGALLERY['BACK_STRING'],
        'HIDDEN' => $hidden,
    ]);

//
    if (!empty($aktuelleKat))
    {
        $separator = ' » ';
//        $tpl->parse('SHOW_BREADCRUMB', 'show_breadcrumb_block', true);
        $aPath = explode('/', $aktuelleKat);
        $breadcrumb = '<ul class="fg_pages_nav">'
               .'<li><a href="'
               .$link
               .'"  class="catbacklink">'
               .$MOD_FOLDERGALLERY['BACK_STRING']
               .'</a>'.$separator.'</li>';
        // first element is empty as the string begins with /
        array_shift($aPath);
        $iLast = sizeof($aPath)-1;
        foreach ($aPath as $i => $cat_name) {
           $aSql[12] = '
           SELECT `cat_name`, `id` FROM `'.$sTablePrefix.'mod_foldergallery_categories`
           WHERE `categorie` = \''.$cat_name.'\'
             AND  `section_id` = '.$section_id.'
             AND `active` = 1
           ';
           if (($catres = $database->query($aSql[12]))) {
            $cat = $catres->fetchRow(MYSQLI_ASSOC);
            $sAktKatName = ucfirst($cat['cat_name']);

            if (!empty($sAktKatName)) {
//                $cat = $catres->fetchRow(MYSQLI_ASSOC);
                $breadcrumb .= '<li> '.(($i!=$iLast) ? '<a href="'
                   .$link
//                   .'?cat='.$cat['id']
                   .'?cat=/'.implode('/', array_slice($aPath, 0, ($i + 1))).'&amp;section_id='.$section_id
                   .'" class="catlink">'.$sAktKatName.'</a>'.$separator.'':$sAktKatName).'</li>';
            }else{
                $breadcrumb .= '';
                }
            }
        } //end for
        $breadcrumb .= '</ul>';

        $tpl->set_var('CATBREAD', $breadcrumb);
        $tpl->parse('SHOW_BREADCRUMB', 'show_breadcrumb_block', true);
        $tpl->set_var('CATEGORIES_TITLE', $sAktKatName);
    }

#############################################################################
##                               show categories                           ##
#############################################################################
// Kategorien anzeigen

    if (count($unterKats))
    {
        $anzahlGal = count($unterKats);
        $current_gal = 1;
        $settings['gal_pp'] = (($settings['gal_pp']<=0)? $anzahlGal+1 :$settings['gal_pp']);
        if ($anzahlGal > $settings['gal_pp'])
        {
            $galleries = ceil($anzahlGal / $settings['gal_pp']);
            if (isset($aRequestVars['g']) && is_numeric($aRequestVars['g']))
            {
                if ($aRequestVars['g'] <= $galleries) {
                    $current_gal = $aRequestVars['g'];
                } else {
                    $current_gal = 1;
                }
            } else {
                $current_gal = 1;
            }
            $gal_navi = '';//
            for ($i = 1; $i <= $galleries; $i++)
            {
                $gal_navi_query = '';
                $gal_navi_current = '';
                //erzeugt nur ein ?cat wenn auch $aktuelleKat nicht leer ist verhindert notice Warunung
                if (empty($aktuelleKat)){
//                    $gal_navi .= '<li><a href='.$link.'?g='.$i.' ';
                }else{
//                    $gal_navi .= '<li><a href='.$link.'&cat='.$aktuelleKat.'&g='.$i.' ';
                    $gal_navi_query = '&cat='.$aktuelleKat;
                }
                if (isset($aRequestVars['g']) && $aRequestVars['g'] == $i) {
//                    $gal_navi .= ' class="current"';
                    $gal_navi_current = 'current';
                }
//                $gal_navi .= '>'.$i.'</a></li>';
//            }
                $tpl->set_var(
                            [
                            'GAL_NAV_LINK' => $link,
                            'GAL_NAV_ID' => $i,
                            'GAL_NAV_QUERY' => $gal_navi_query,
                            'GALE_NAV_CURRENT' => $gal_navi_current,
                            ]
                        );
              $tpl->parse('list_galnav', 'list_galnav_block', true);
            }
            $tpl->set_var('GAL', $MOD_FOLDERGALLERY['GAL']);
            $tpl->parse('show_galnav', 'show_galnav_block');
        } else {
            $tpl->clear_var('galnav');
        }
        $offset1 = ( $settings['gal_pp'] * $current_gal - $settings['gal_pp'] );

        for ($ix = 0; $ix < $anzahlGal; $ix++)
        {
            $aSql[13] = '
            SELECT COUNT(*) FROM `'.$sTablePrefix .'mod_foldergallery_categories`
            WHERE `parent_id` = '.$unterKats[$ix]['parent_id'].'
              AND `active` = 1
            ';
            $query = $database->query($aSql[13]);
                if (($result = $query->fetchRow(MYSQLI_BOTH))) {
                    $subkatcount[$ix] = $result[0];
                } else {
                    $subkatcount[$ix] = 0;
                };
            $aSql[14] = '
            SELECT COUNT(*) `count` FROM `'.$sTablePrefix .'mod_foldergallery_files`
            WHERE `parent_id` = '.$unterKats[$ix]['parent_id'].'
              AND `active` = 1
            ';
            $oFiles = $database->query($aSql[14]);
            if (($aFiles = $oFiles->fetchRow(MYSQLI_ASSOC))) {
                if ($aFiles['count'] > 0){
                    $katcount[$ix] = $aFiles['count'];
                }else{
                    $katcount[$ix] = '';
                }
            } else {
                $katcount[$ix] = '';
            };

            if($katcount[$ix] == "1") {
                $katcount[$ix].= " ".$MOD_FOLDERGALLERY['1PICTURE'];
            } else if($katcount[$ix] == "2") {
                $katcount[$ix].= " ".$MOD_FOLDERGALLERY['2PICTURES'];
            } else if($katcount[$ix] == "3") {
                $katcount[$ix].= " ".$MOD_FOLDERGALLERY['3PICTURES'];
            } else if($katcount[$ix] == "4") {
                $katcount[$ix].= " ".$MOD_FOLDERGALLERY['3PICTURES'];
            }else{
                if (($katcount[$ix] === '') && ($subkatcount[$ix] > 0)){
                    if($subkatcount[$ix] == 1){
                        $katcount[$ix].= $subkatcount[$ix]." ".$MOD_FOLDERGALLERY['CATEGORIE'];
                    }else{
                        $katcount[$ix].= $subkatcount[$ix]." ".$MOD_FOLDERGALLERY['CATEGORIES'];}
                }else{
                    $katcount[$ix].= " ".$MOD_FOLDERGALLERY['PICTURES'];
                }
            };
            $sCatGalleryLink = $unterKats[$ix]['link'];
            $sCatThumbUrl = (!is_dir($unterKats[$ix]['thumb']) ? $unterKats[$ix]['thumb'] : '');
            $sCatName = $unterKats[$ix]['name'];
            $tpl->set_var('CATEGORIES_TITLE', $MOD_FOLDERGALLERY['CATEGORIES_TITLE']);
            $isEmpty = ((intval($katcount[$ix])==0) ? true : $isEmpty);
            $bIsThumbLink = !empty($sCatThumbUrl);
            if ($isEmpty && !$bIsAdmin){continue;}
            $aCategorie = [
                'CAT_LINK' => $sCatGalleryLink,
                'THUMB_LINK' => $sCatThumbUrl.'?t='.time(),
                'CAT_CAPTION' => $sCatName,
                'CATEGORIES_TITLE' => $title,
                'CAT_DESCRIPTION' => $description,
                'CAT_COUNT' => $katcount[$ix],
                'IsEmpty' =>$isEmpty
            ];

            $tpl->set_var($aCategorie);

            $iRatio = (float)($aLoadPresets['ratio']['thumb_ratio']);
            $iRatio = (float)(($iRatio>1) ? $iRatio : 1.34);
            $catWidth   = (float)$settings['tbSettings']['image_x'];
            $catHeight  = abs($catWidth * $iRatio);
            $catHeight  = (float)($settings['tbSettings']['image_y']);
            $tpl->set_var([
                'CATWIDTH'  => $catWidth,
                'CATHEIGHT' => $catHeight,
                'WORDCOUNT' => str_word_count($title)*3,
            ]);

            $tpl->parse('SHOW_CATEGORIES', 'show_categories', true);
            // Image visible or invisible?
            if (($ix < $offset1)) {
                $tpl->parse('GALINVISIBLEPRE', 'galinvisiblePre', true);
            } elseif ($ix > ($offset1 + $settings['gal_pp'] - 1)) {
                $tpl->parse('GALINVISIBLEPOST', 'galinvisiblePost', true);
            } else {;
                $tpl->parse('GALTHUMBNAILS', 'galthumbnails', true);
            }
        } // end for
        $tpl->parse('GALIMAGES', 'galimages', true);
    } else {
        $tpl->clear_var('show_categories');
        $tpl->clear_var('categories');
    }

    $tpl->set_var('TEXT_ALIGNMENT', $settings['alignment']);

// Fertig Kategorien angezeigt
#############################################################################
##                               show images                               ##
#############################################################################

// Bilder anzeigen
    if (!empty($bilder))
    {
        $sDefaultOpacity = $settings['opacity'];
        $argba = $ColorConverter($settings['tbSettings']['image_background_color']);
        $rgba  = implode(',', $argba).','.$sDefaultOpacity;
        $aColorSettings = array(
//        'defaultOpacity' => $settings['opacity'],
        'BACKGROUND_COLOR' => $rgba,
        );
        $tpl->set_var($aColorSettings);

        $anzahlBilder = count($bilder);
        $settings['pics_pp'] = (($settings['pics_pp']<=0)? $anzahlBilder+1 :$settings['pics_pp']);
        if ($anzahlBilder > $settings['pics_pp']) {
            $pages = ceil($anzahlBilder / $settings['pics_pp']);
        }
        if (isset($aRequestVars['p']) && is_numeric($aRequestVars['p'])) {
            if ($aRequestVars['p'] <= $pages) {
                $current_page = $aRequestVars['p'];
            } else {
                $current_page = 1;
            }
        } else {
            $current_page = 1;
        }
        $description = ($aW3Advanced['description'] ?? $description);
        $tpl->set_var('CATEGORIES_TITLE', $title);
        $tpl->set_var('CAT_DESCRIPTION', $description);
        if (is_numeric($pages))
        {
            for ($i = 1; $i <= $pages; $i++)
            {
                $pages_navi_query = '';
                $pages_navi_current = 'pages';
                //erzeugt nur ein ?cat wenn auch $aktuelleKat nicht leer ist verhindert notice Warunung
                if (empty($aktuelleKat)){
                    $pages_navi_query = '';//  <li><a href='.$link.'?p='.$i.'
                }else{
                    $pages_navi_query = '&cat='.$aktuelleKat.'&amp;section_id='.$section_id.''; // <li><a href='.$link.'?cat='.$aktuelleKat.'&p='.$i.'
                }
                if (isset($aRequestVars['p']) && $aRequestVars['p'] == $i) {
                    $pages_navi_current = 'current';
                }
                $tpl->set_var(
                            [
                            'PAGE_NAV_LINK' => $link,
                            'PAGE_NAV_ID' => $i,
                            'PAGE_NAV_QUERY' => $pages_navi_query,
                            'PAGE_NAV_CURRENT' => $pages_navi_current,
                            ]
                        );
              $tpl->parse('list_pagenav', 'list_pagenav_block', true);
            } // end for
            $tpl->set_var('PAGE', $MOD_FOLDERGALLERY['PAGE']);
            $tpl->parse('show_pagenav', 'show_pagenav_block');
       } else {
            $tpl->clear_var('pagenav');
//            $tpl->set_block('list_pagenav_block', '');
            $tpl->parse('show_pagenav_block', '');
        }
        $offset = ( $settings['pics_pp'] * $current_page - $settings['pics_pp'] );
        $tpl->set_var($aW3Advanced);
        for ($i = 0; $i < $anzahlBilder; $i++)
        {
            if (empty($bilder[$i])) {continue;}
            $bildfilename = basename($bilder[$i]['file_name']);
            $urlToFolder  = $folder; // rel Url
            $urlToThumb   = $url.$folder.$thumbDirName.'/';
            $pathToThumb  = $oReg->AppPath.$folder.$thumbDirName; //
            $thumb        = $pathToThumb.'/'.($bildfilename);
            $thumburl     = $urlToThumb.($bildfilename);
            $file         = $oReg->AppPath.$pathToFolder.$bildfilename; //
            if (($bilder[$i]['id']!=0) && (!is_file(DirectoryHandler::DecodePath($file)))) {
                $sqlEOL = (\defined('DEBUG') && DEBUG ? PHP_EOL : '');
                $aSql[15] = '
                DELETE FROM `'.$sTablePrefix.'mod_foldergallery_files`
                WHERE `id` ='.$bilder[$i]['id'].'
                  AND `parent_id`='.(int)$bilder[$i]['parent_id'].'
                  AND `section_id`='.(int)$section_id.'
                ';
                if (!($database->query($aSql[15]))){
                    echo PreCheck::xnl2br(sprintf("[%d] %s\n %s",__LINE__,$aSql[12],$pathToFolder.$bildfilename));//
                    continue;
                }
            }
// create images thumbs for actuelly categorie
            $sImagePattern = '/.*?(unknown_).*?/is';
            if (!is_readable(DirectoryHandler::DecodePath($thumb))&& !preg_match($sImagePattern, $thumb)) {
                $file = $oReg->AppPath.$pathToFolder.($bildfilename);
                FG_createThumb($file, ($bildfilename), $pathToThumb, $settings['tbSettings']);
            } else
            if ($settings['lightbox'] != 'contentFlow'){
                $timeadd = '?t='.time();
            }else{
                $timeadd = '';
            }
   // what shall we show as lightbox title/caption
            $sCaption = '';
            $sOrginalFilename = $bildfilename;
            if ($settings['imageName']){
                $bildfilename = ($bilder[$i]['img_title']!='' ? $bilder[$i]['img_title'] : ((intval($settings['imageName']) > 0) ? $bildfilename : ''));
                $sCaption = (($bilder[$i]['caption']!='') ? $bilder[$i]['caption'] : $bildfilename);
            }
            $ImageSizeFile = str_replace(['\\','//','\\\\'],'/',$oReg->AppPath.$pathToFolder.$sOrginalFilename);
            $ImgInfo = (is_readable($ImageSizeFile) ? getimagesize($ImageSizeFile) : null);
//            'preview.php?img='.$urlToFolder.$sOrginalFilename
            $sImageFile = function ($sImage) use ($ImgInfo){
                return __DIR__.'/preview.php?img='.$sImage;  // '
            };
            $sFilename = $url.$pathToFolder.$sOrginalFilename;
//            $sImageFilename = $sImageFile($pathToFolder.$sOrginalFilename);
            $aShowImages = [
                'ORIGINAL' => $sFilename,
                'ALT_NAME' => $sOrginalFilename,
                'THUMB'    => $thumburl.'?t='.time(),
//                'CAPTION'  => $sCaption,
                'NUMBER'   => $i
            ];
            $tpl->set_var($aShowImages);
            if (!empty ($sCaption)){
                $tpl->set_var(['CAPTION'  => $sCaption]);
                $tpl->parse('show_caption', 'show_caption_block', false);
            } else {
                $tpl->clear_var('show_caption_block');
            }

            $iRatio = floatval($aLoadPresets['ratio']['image_ratio']);
            $iRatio = floatval(($iRatio > 0) ? $iRatio : 1.34);
            $catWidth  = $settings['tbSettings']['image_x']; //  * 1.34
            $catHeight = abs($catWidth * $iRatio);
            $catHeight = $catHeight;
            $galWidth  = $catWidth;
            $galHeight = $galWidth * $iRatio;

            $aShowCats = [
                'CATWIDTH'  => $catWidth,
                'CATHEIGHT' => $catHeight,
                'GALWIDTH'  => $galWidth,
                'GALHEIGHT' => $galHeight,
                'WORDCOUNT' => str_word_count($title)*2,
            ];
            $tpl->set_var($aShowCats);
            // Bild sichtbar oder unsichtbar?
            if ($i < $offset) {
                $tpl->parse('INVISIBLEPRE', 'invisiblePre', true);
            } elseif ($i > ($offset + $settings['pics_pp'] - 1)) {
                $tpl->parse('INVISIBLEPOST', 'invisiblePost', true);
            } else {
                $tpl->parse('THUMBNAILS', 'show_thumbnails_block', true);
            }
            $tpl->parse('list_images', 'list_images_block', true);

        } // end for bilder
        $tpl->parse('IMAGES', 'show_images_block', true);
    } else {
        $tpl->clear_var('show_thumbnails_block');
        $tpl->clear_var('show_images_block');
        $tpl->clear_var('list_images_block');
        $tpl->clear_var('show_caption_block');
    }

// Kategorien
    if ($bilder && $unterKats) {
        $tpl->parse('HR', 'hr_block', true);
    } else {
        $tpl->clear_var('hr_block');
    }
//ueberschreibt die fest eingestellte Groesse von ul.categories li a auf die Thumbgroessenwerte
/*
    $catWidth  = $settings['tbSettings']['image_x'] + 10;
    $catHeight = $settings['tbSettings']['image_y'] - str_word_count($title)*3;
    $tpl->set_var(array(
    'CATWIDTH'  => $catWidth,
    'CATHEIGHT' => $catHeight,
    'WORDCOUNT' => str_word_count($title)*3,
    ));
    $tpl->parse('view', 'view');
*/
    $tpl->parse('main', 'main_block', false);
    $tpl->pparse('output', 'view');

}catch (\Exception $ex) {
    $sErrMsg = PreCheck::xnl2br(\sprintf('<h5 class="w3-panel w3-leftbar w3-sand w3-container">%s</h5>', $ex->getMessage()));
    echo $sErrMsg;
}
